/*
 功能：自定义列表控件
 作者：FQQ
 日期：2016.03.01
 * */
var listview = function(p) {
    var order = p.order || "asc";
    var fel = $('<div class="ubt bc-border sc-bg"></div>');
    if (p.selector) {
        $(p.selector).append(fel);
    }
    p.hasAngle = p.hasAngle == null ? true : p.hasAngle;
    var events = {
    };
    this.setOrder = function(o) {
        order = o;
    }
    var isWindows = function() {
        if (!('ontouchstart' in window))
            return true;
    }
    var fval = function(dt, fn) {
        return p[fn + 'Render'] ? (p[fn + 'Render'](dt, dt[fn]) || '') : (dt[fn] || '');
    }
    var fcss = function(dt, fn) {
        return p[fn + 'CssRender'] ? (p[fn + 'CssRender'](dt, dt[fn]) || '') : dt[fn + 'Css'] || p[fn + 'Css'] || '';
    }
    var makeele = function(data, html, appendEl) {
        var exp;
        var b_minline = p.miniLine && !data.isGroup && !data.noborder;
        var ele = $('<div id="item' + data.id + '" class="item ubb ub ' + ((p.miniLine || data.noborder) ? 'lv-noborder' : 'bc-border') + ' bc-text ub-ac lis ' + (p.cssRender ? p.cssRender(data) : '') + ' ' + (p.css || data.css || '') + (data.isGroup ? ' lv-groupline ' : '') + '" data-index="' + data.id + '" ></div>');
        ele.html(html);
        $('input[type=checkbox]', ele).change(function() {
            if (events.click) {
                events.click(ele[0]);
            }
        });
        $('input[type=radio]', ele).change(function() {
            if (events.click) {
                events.click(ele[0]);
            }
        });
        ele.on('tap', function(evt) {
            ele.removeClass("sc-bg-active");
            var hasbox = $("input", this);
            var boxtype = hasbox.attr('type');
            if (hasbox && boxtype == "checkbox") {
                if ($(evt.target).is('input[type=checkbox]')) {
                    return;
                }
                var cbox = ele.find("input")[0];
                cbox.checked = !cbox.checked;
            }
            if (hasbox && boxtype == "radio") {
                if ($(evt.target).is('input[type=radio]')) {
                    return;
                }
                var cbox = ele.find("input")[0];
                cbox.checked = true;
            }
            if (events.click) {
                events.click(this);
            }
            if (data.hasExpand) {
                if (exp[0].style.display == "none") {
                    exp[0].style.display = "";
                    $(".angle",this)[0].className = "angle fa fa-angle-up ulev2 " + (p.type == "thickLine" ? "" : "sc-text");
                    if (ele.attr("expand") == "list" && data.listType != "button") {
                        selectExpand(ele, exp, data);
                    }
                    if (events.expand) {
                        events.expand(this, exp, data);
                    }
                } else {
                    exp[0].style.display = "none";
                    $(".angle",this)[0].className = "angle fa fa-angle-down ulev2 " + (p.type == "thickLine" ? "" : "sc-text");
                    if (events.collapse) {
                        events.collapse(this, exp, data);
                    }
                }
            }
        });
        ele.on(isWindows() ? 'mousedown' : 'touchstart', function(evt) {
            ele.addClass("sc-bg-active");
            setTimeout(function() {
                ele.removeClass("sc-bg-active");
            }, 300);
        });
        ele.on('longTap', function(evt) {
            if (events.longClick) {
                events.longClick(this);
            }
        });
        ele.on('cancleTap', function(evt) {

        });
        if (data.switchBtn && events.switchChange) {
            appcan.switchBtn($(".switch", ele), function(obj, value) {
                events.switchChange(obj[0], obj.attr("itemid"), value);
            });
        }
        if (p.hasCheckbox && events.checkboxChange) {
            $("[type=checkbox]", ele).on("change", events.checkboxChange);
        }
        if (p.hasRadiobox && events.radioChange) {
            $("[type=radio]", ele).on("change", events.radioChange);
        }

        if (order == 'desc') {
            var fele = appendEl[0];
            if (fele.childNodes.length > 0) {
                if (b_minline) {
                    $('<div class="lv-inner-bottom"></div>').insertBefore(fele.childNodes[0]);
                }
                $(ele).insertBefore(fele.childNodes[0]);
            } else {
                appendEl.append(ele);
                if (b_minline) {
                    appendEl.append($('<div class="lv-inner-bottom"></div>'));
                }
            }
        } else {
            appendEl.append(ele);
            if (b_minline) {
                appendEl.append($('<div class="lv-inner-bottom"></div>'));
            }
        }
        if (data.hasExpand) {
            exp = $('<div id="itemexp' + data.id + '" style="display:none;' + (data.data ? 'margin-left:2em;' : '') + '"></div>');
            appendEl.append(exp);
            if (data.data) {
                for (var i = 0; i < data.data.length; i++) {
                    thinLine(data.data[i], exp);
                }
            } else if (data.list) {
                makeExpand(ele, exp, data);
            }
        }
    }
    var selectExpand = function(el, ep, data) {
        for (var i = 0; i < ep[0].childNodes.length; i++) {
            $(ep[0].childNodes[i]).removeClass("lv-list-selected");
            if ($(".subTitle",el)[0].innerHTML == ep[0].childNodes[i].innerHTML) {
                $(ep[0].childNodes[i]).addClass("lv-list-selected");
            }
        }
    }
    var makeExpand = function(el, ep, dt) {
        var dl = dt.list;
        el.attr("expand", "list");
        for (var i = 0; i < dl.length; i++) {
            var listel = $('<div class="btn ub ub-ac ub-pc ubb bc-border lv-list" value="' + dl[i].value + '">' + dl[i].text + '</div>');
            ep.append(listel);
            appcan.button(listel, "btn-act", function() {
                if (dt.autoCollapse != false) {
                    ep.hide();
                }
                $(".angle",el)[0].className = "angle fa fa-angle-down ulev2 " + (p.type == "thickLine" ? "" : "sc-text");
                if (events.listClick) {
                    events.listClick(el[0], this);
                }
                if (events.collapse) {
                    events.collapse(el[0], this);
                }
            });
        }
    }
    this.makeExpand = function(id, dt, or) {
        var el = $("#item" + id, fel);
        var ep = $("#itemexp" + id, fel);
        if (or != false) {
            ep.html('');
        }
        makeExpand(el, ep, dt);
    }
    var checkel = function(type, data) {
        if (type == "cbox") {
            return '<div class="checkbox umar-' + (p.align == 'right' ? 'l' : 'r') + '"><input type="checkbox" ' + (data.checked == true ? 'checked="checked"' : '') + ' class="uabs ub-con" itemid="item' + data.id + '"></div>';
        } else if (type == "rbox") {
            return '<div class="radiobox umar-' + (p.align == 'right' ? 'l' : 'r') + '" name=""><input type="radio" ' + (data.checked == true ? 'checked="checked"' : '') + ' class="uabs ub-con" itemid="item' + data.id + '" name="' + (data.name || p.name || '') + '"></div>';
        } else if (type == "switch") {
            return '<div class="switch uba bc-border ' + (data.switchBtn.value ? (data.switchBtn.mini ? ' switch-mini ' : '') + ' bc-head" data-checked="true"' : (data.switchBtn.mini ? ' switch-mini ' : '') + '" data-checked="false"') + 'itemid="item' + data.id + '" ><div class="switch-btn sc-bg-active "></div></div>';
        }
    }
    var logoel = function(data) {
        return '<div class="logo fa ' + fval(data, 'logo') + ' umar-' + ((data.logoAlign || p.logoAlign) == "right" ? 'l' : 'r') + ' ' + fcss(data, 'logo') + '" style="font-size:' + (data.logoSize || (p.logoSize || 2)) + 'em;"></div>';
    }
    var thinLine = function(data, appendEl) {
        var html = "";
        var tocss = 'ub ub-ver ub-f1 ut-m line1';
        if (p.align == 'left' || p.align == null) {
            html += ((p.hasCheckbox && data.hasCheckbox != false) || data.hasCheckbox) ? checkel('cbox', data) : '';
            html += ((p.hasRadiobox && data.hasRadiobox != false) || data.hasRadiobox) ? checkel('rbox', data) : '';
        }
        if ((data.logo || p.logoRender) && ((data.logoAlign || p.logoAlign) == "left" || (data.logoAlign || p.logoAlign) == null)) {
            html += logoel(data);
        }
        html += p.hasIcon && (data.icon || p.iconRender) ? '<div class="icon lis-icon-s ub-img ' + fcss(data, 'icon') + '" style="background-image:url(' + fval(data, 'icon') + ')"></div>' : '';
        html += '<div class="title ' + ((data.subTitleCut != false && p.subTitleCut) ? '' : tocss) + ' lv_title umar-r marg-l ' + fcss(data, 'title') + '">' + fval(data, 'title') + '</div>';
        html += p.hasSubTitle ? '<div class="subTitle ' + ((data.subTitleCut != false && p.subTitleCut) ? tocss : '') + ' tx-r sc-text ulev-1 umar-r lv_subTitle ' + fcss(data, 'subTitle') + '">' + fval(data, 'subTitle') + '</div>' : '';
        html += (p.hasAngle || data.hasAngle) && data.noAngle != true && data.isGroup != true ? '<div class="angle fa fa-angle-' + (data.hasExpand ? 'down' : 'right') + ' ulev2 sc-text ' + fcss(data, 'angle') + '"></div>' : '';
        html += (p.hasControl && data.switchBtn) ? checkel('switch', data) : '';
        if ((data.logo || p.logoRender) && (data.logoAlign || p.logoAlign) == "right") {
            html += logoel(data);
        }
        if (p.align == 'right') {
            html += p.hasCheckbox ? checkel('cbox', data) : ''
            html += p.hasRadiobox ? checkel('rbox', data) : '';
        }
        makeele(data, html, appendEl);
    }
    var thickLine = function(data, appendEl) {
        var html = '';
        var tocss = 'ub ub-ver ut-m line1';
        if (p.align == 'left' || p.align == null) {
            html += ((p.hasCheckbox && data.hasCheckbox != false) || data.hasCheckbox) ? checkel('cbox', data) : '';
            html += ((p.hasRadiobox && data.hasRadiobox != false) || data.hasRadiobox) ? checkel('rbox', data) : '';
        }
        if ((data.logo || p.logoRender) && ((data.logoAlign || p.logoAlign) == "left" || (data.logoAlign || p.logoAlign) == null)) {
            html += logoel(data);
        }
        if (p.hasIcon && (data.icon || p.iconRender)) {
            var h_icon = data.icon ? '<div class="icon lis-icon ub-img ' + fcss(data, 'icon') + '" style="background-image:url(' + fval(data, 'icon') + ')"></div>' : '';
            var h_icontitle = data.icontitle ? '<div class="icontitle ulev-1 bc-text umar-t ' + fcss(data, 'icontitle') + '">' + fval(data, 'icontitle') + '</div>' : '';
            html += '<div class="ub ub ub-ver"><div class="">' + h_icon + h_icontitle + '</div></div>';
        }
        var t = '<div class="ub ub-ver ' + ((data.subTitleCut != false && p.subTitleCut) ? '' : 'ub-f1') + ' marg-l">';
        t += '<div class="title ' + ((data.subTitleCut != false && p.subTitleCut) ? '' : tocss) + ' umar-r bc-text ' + fcss(data, 'title') + '">' + fval(data, 'title') + '</div>';
        t += (data.describe || p.describeRender) ? '<div class="describe ulev-1 sc-text1 uinn3 ' + fcss(data, 'describe') + '">' + fval(data, 'describe') + '</div>' : '';
        t += (data.note || p.noteRender) ? '<div class="note ulev-2 sc-text1 uinn3 ' + fcss(data, 'note') + '">' + fval(data, 'note') + '</div>' : '';
        t += '</div>';
        var st = '';
        if (p.hasSubTitle) {
            st += '<div class="ub ' + ((data.subTitleCut != false && p.subTitleCut) ? 'ub-f1' : '') + ' ub-ver ub-ae umar-r ">';
            st += '<div class="subTitle ' + ((data.subTitleCut != false && p.subTitleCut) ? tocss : '') + ' bc-text lv_subTitle ' + fcss(data, 'subTitle') + '">' + fval(data, 'subTitle') + '</div>';
            st += (data.subDescribe || p.subDescribeRender) ? '<div class="subDescribe ulev-1 sc-text1 uinn3 ' + fcss(data, 'subDescribe') + '">' + fval(data, 'subDescribe') + '</div>' : '';
            st += (data.subNote || p.subNoteRender) ? '<div class="subNote ulev-2 sc-text1 uinn3 ' + fcss(data, 'subNote') + '">' + fval(data, 'subNote') + '</div>' : '';
            st += '</div>';
        }
        var h_angle = (p.hasAngle || data.hasAngle) && data.noAngle != true && data.isGroup != true ? '<div class="angle fa fa-angle-' + (data.hasExpand ? 'down' : 'right') + ' ulev2 ' + fcss(data, 'angle') + '"></div>' : '';
        var h_switch = (p.hasControl && data.switchBtn) ? checkel('switch', data) : '';
        html += '<div class="ub-f1 ub ub-pj ub-ac">' + t + st + h_switch + h_angle;
        if ((data.logo || p.logoRender) && (data.logoAlign || p.logoAlign) == "right") {
            html += logoel(data);
        }
        if (p.align == 'right') {
            html += p.hasCheckbox ? checkel('cbox', data) : ''
            html += p.hasRadiobox ? checkel('rbox', data) : '';
        }
        makeele(data, html + '</div>', appendEl);
    }
    this.set = function(dt, add, appendEl) {
        if (add != true) {
            (appendEl || fel).html('');
        }
        if (p.type == "thickLine") {
            for (var i = 0; i < dt.length; i++) {
                thickLine(dt[i], appendEl || fel);
            }
        } else {
            for (var i = 0; i < dt.length; i++) {
                thinLine(dt[i], appendEl || fel);
            }
        }
    }
    this.add = function(dt) {
        this.set(dt, true);
    }
    this.on = function(type, f) {
        events[type] = f;
    }
    this.setSwitch = function(id, state, appendEl) {
        var sbtn = $(".switch", $("#item" + id, appendEl || fel));
        var value = sbtn.attr("data-checked") || 'false';
        if (state == true) {
            sbtn.attr("data-checked", 'true');
            sbtn.removeClass("switch-active")
            sbtn.addClass("bc-head");
        } else {
            sbtn.attr("data-checked", 'false');
            sbtn.addClass("switch-active")
            sbtn.removeClass("bc-head");
        }
    }
    this.getSwitch = function(id, appendEl) {
        var sbtn = $(".switch", $("#item" + id, appendEl || fel));
        return sbtn.attr("data-checked") == 'true' ? true : false;
    }
    this.appendTo = function(obj) {
        $(obj).append(fel);
    }
    if (p.data) {
        this.set(p.data);
    }
    return this;
}
