/*
 功能：APPCAN基础方法封装
 作者：FQQ
 日期：2016.02.02
 **/

var b = {
    /*缓存前缀字符*/
    cacheLeader : 'xysoft_',
    namespace : "b",
    /*判断是否是电脑操作*/
    isWindows : function() {
        if (!('ontouchstart' in window))
            return true;
    },
    /*通过ID返回页面EL元素*/
    el : function(id) {
        return document.getElementById(id);
    },

    /*为空时转换*/
    ifnull : function(v, t) {
        return b.isnull(v) == true ? t : v;
    },

    /*判断是否为空[v：比较的值，ab(allowBlank)：是否允许空字符串]*/
    isnull : function(v, ab) {
        return v === null || v === undefined || ((appcan.isArray(v) && !v.length)) || (!ab ? v === '' : false);
    },
    /*判断是否为数字*/
    isnumber : function(v) {
        if (b.trim(v) == "")
            return false;
        return !isNaN(v);
    },
    /*某个值是否包含一组值中*/
    isin : function(v, a) {
        for (var i = 0; i < a.length; i++) {
            if (v == a[i]) {
                return true;
            }
        }
        return false;
    },
    /*获取0--100以内 的随机数*/
    random : function() {
        return Math.floor((Math.random() * 10000) * (Math.random() * 100));
    },
    /*适配iphonex及以上*/
    fitIphonex : function() {
        var u = navigator.userAgent;
        var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
        //ios终端
        if (isIOS) {
            if ((screen.height == 780 && screen.width == 360) || (screen.height == 812 && screen.width == 375) || (screen.height == 896 && screen.width == 414) || (screen.height == 844 && screen.width == 390) || (screen.height == 926 && screen.width == 428)) {
                //是iphoneX||xs||max||xr||12 mini||12/12 Pro||12 Pro Max||13 mini||13/13 Pro||13 Pro Max
                try {
                    $(".uh").css("padding", "2em 0 0");
                    $("#id_footer").css("padding", ".55em 0 1em");
                } catch(e) {
                }
            }
        }
    },
    /*获取当前时间*/
    nowdatetime : function(format) {
        var date = new Date();
        var y = date.getFullYear();
        var m = date.getMonth() + 1;
        var d = date.getDate();
        var h = date.getHours();
        var mi = date.getMinutes();
        var second = date.getSeconds();
        m = m < 10 ? "0" + m : m;
        d = d < 10 ? "0" + d : d;
        h = h < 10 ? "0" + h : h;
        mi = mi < 10 ? "0" + mi : mi;
        second = second < 10 ? "0" + second : second;
        if (format == "date") {
            return y + "-" + m + "-" + d;
        } else if (format == "time") {
            return h + ":" + mi;
        } else if (format == "datetime") {
            return y + "/" + m + "/" + d + " " + h + ":" + mi + ":" + second;
        } else if (format == "today") {
            return y + m + d;
        } else if(format == "datetime2") {
            return y + "" + m + "" + d + "" + h + "" + mi + "" + second;
        }
    },
    /*数组排序*/
    sort : function(array, ot, key) {
        ot = (ot || 'ASC').toLocaleUpperCase();
        if (array && array.length > 0) {
            for (var i = 0; i < array.length; i++) {
                for (var j = i + 1; j < array.length; j++) {
                    var bool = false;
                    if (key) {
                        bool = array[j][key] < array[i][key];
                    } else {
                        bool = array[j] < array[i];
                    }
                    if (bool && (ot == 'ASC') || !bool && (ot == 'DESC')) {
                        var b = array[i];
                        array[i] = array[j];
                        array[j] = b;
                    }
                };
            };
        }
        return array;
    },
    /*字符串替换*/
    replace : function(s, o, n) {
        return (s || "").replace(eval('/' + o + '/g'), n);
    },

    /*在指定的窗口脚本执行*/
    escript : function(name, script, type) {
        appcan.window.evaluateScript(name, script, type);
    },

    /*在指定的弹出窗口脚本执行*/
    epscript : function(name, popName, script) {
        appcan.window.evaluatePopoverScript(name, popName, script);
    },

    /*消息弹出*/
    msg : function(text, fun) {
        if (fun) {
            appcan.window.confirm("提示", text, ["确定", "取消"], function(err, data, dataType, optId) {
                fun(data);
            });
        } else {
            appcan.window.alert("提示", text, ["确定"], null);
        }
    },
    /*去掉空格*/
    trim : function(text) {
        if ( typeof (text) == "string") {
            return text.replace(/(^\s*)|(\s*$)/g, "");
        }
    },
    /*字符串转JSON*/
    s2j : function(str) {
        return eval('(' + str + ')');
    },
    /*JSON转字符串*/
    j2s : function(json) {
        return JSON.stringify(json);
    },
    /*文本输入框内容转HTML内容 格式化*/
    text2html : function(t) {
        t = b.replace(t, "\\n", "<br/>");
        t = b.replace(t, " ", "&nbsp;");
        return t;
    },
    /*文本输入框内容转HTML内容 格式化*/
    html2text : function(t) {
        t = b.replace(t, "<br/>", "\\n");
        t = b.replace(t, "&nbsp;", " ");
        return t;
    },
    /*设置HTML节点属性*/
    sattr : function(e, p, v) {
        e.setAttribute(p, v);
    },
    /*获取HTML节点属性*/
    gattr : function(e, p) {
        return e.getAttribute(p);
    },
    /*查询数组array_listitem,{ id:str_autoOpenItem}*/
    getArrayItem : function(a, w) {
        var na = [];
        for (var i = 0; i < a.length; i++) {
            for (var p in w) {
                if (a[i][p] == w[p]) {
                    na.push(a[i]);
                }
            }
        }
        return na;
    },
    /*验证是否有特殊字符'*/
    validData : function(type, text) {
        var reg;
        if (type == "special") {
            reg = /["'&^]/;
        }
        return reg.test(text);
    },
    /*ajax[异步]数据请求*/
    ajax : function(url, p, f, cache) {
        var cachekey = "";
        p.LoginToken = login.LoginToken;

        if (!b.isnull(cache) && cache == true) {
            var cacheparams = {
                url : url,
                apploginuserId : login.userId
            };
            for (var i in p) {
                cacheparams[i] = p[i];
            }
            cachekey = escape(b.j2s(cacheparams));
        }
        appcan.ajax({
            url : url,
            type : p.type || 'POST',
            data : p,
            dataType : "text",
            timeout : 30000,
            success : function(d, status, requestCode, response, xhr) {
                f(true, b.s2j(d));
                if (!b.isnull(cache) && cache == true) {
                    appcan.locStorage.setVal(cachekey, d);
                }
            },
            error : function(xhr, errorType, error, msg) {
                if (msg == null || msg == "A connection failure occurred" || msg == "The request timed out") {
                    f(false, b.s2j('{msg:"请求服务器失败,超时或网络卡顿"}'));
                    return;
                }
                var msgdata = b.s2j(msg);
                if (msgdata.responseStatusCode == 401) {
                    if (login.loginAccount && login.loginPassword) {
                        login.loadLoginInfo(login.loginAccount, login.loginPassword, function(state, v) {
                            if (v.success == true) {
                                b.ajax(url, p, f);
                            } else {
                                b.alert('登录授权过期,请重新登录');
                            }
                        });
                    } else {
                        b.alert('登录授权过期,请重新登录');
                    }
                } else {
                    var d = msg || '{msg:"未登录"}';
                    if (!b.isnull(cache) && cache == true) {
                        d = appcan.locStorage.getVal(cachekey) || '{}';
                    }
                    f(false, b.s2j(d));
                }

            },
            complete : function(xhr, status) {
            }
        });
    },
    /*ajax[同步]数据请求*/
    ajaxasync : function(url, p, f) {
        p.LoginToken = login.LoginToken;
        $.ajax({
            type : p.type || 'GET',
            url : url,
            data : p,
            cache : false,
            async : false,
            dataType : "text",
            error : function(xhr, errorType, error) {
                if (error == "Unauthorized") {
                    if (login.loginAccount && login.loginPassword) {
                        login.loadLoginInfo(login.loginAccount, login.loginPassword, function(state, v) {
                            if (v.success == true) {
                                b.ajaxasync(url, p, f);
                            } else {
                                b.alert('登录授权过期,请重新登录');
                            }
                        });
                    } else {
                        b.alert('登录授权过期,请重新登录');
                    }
                } else {
                    var d = '{msg:"登录授权过期,请重新登录"}';
                    f(false, b.s2j(d));
                }
            },
            success : function(obj) {
                f(true, b.s2j(obj));
            }
        });
    },
    /*设置本地值{name:value}*/
    lsset : function(p) {
        for (var i in p) {
            appcan.locStorage.setVal(b.cacheLeader + i, p[i]);
        }
    },
    /*获取本地存储值['one','two']返回值{one:1,two:2}*/
    lsget : function(k, rm) {
        if (appcan.isArray(k)) {
            var v = {};
            for (var i = 0; i < k.length; i++) {
                v[k[i]] = appcan.locStorage.getVal(b.cacheLeader + k[i]);
                if (rm) {
                    appcan.locStorage.remove(b.cacheLeader + k[i]);
                }
            }
            return v;
        } else {
            var v = appcan.locStorage.getVal(b.cacheLeader + k);
            if (rm) {
                appcan.locStorage.remove(b.cacheLeader + k);
            }
            return v;
        }
    },
    /*移出本地存储值*/
    lsremove : function(k) {
        if (appcan.isArray(k)) {
            for (var i = 0; i < k.length; i++) {
                appcan.locStorage.remove(b.cacheLeader + k[i]);
            }
        } else {
            appcan.locStorage.remove(b.cacheLeader + k);
        }
    },
    /*移除本地所有键值*/
    lsremoveAll : function() {
        var keys = appcan.locStorage.keys();
        for (var i = 0; i < keys.length; i++) {
            appcan.locStorage.remove(keys[i]);
        }
    },
    /*打开窗口*/
    show : function(url, name, p) {
        /*清除 垃圾缓存键*/
        var keys = appcan.locStorage.keys();
        for (var i = 0; i < keys.length; i++) {
            if (keys[i].indexOf(b.cacheLeader) < 0)
                appcan.locStorage.remove(keys[i]);
        }
        /*********************************************/
        p = p || {};
        appcan.locStorage.setVal("showurlparams", b.j2s(p));
        appcan.window.open({
            aniId : p.aniId != null ? p.aniId : 2,
            name : name || url.split(".")[0],
            data : url,
            type : p.windowType != null ? p.windowType : 0
        });
    },
    /*打开浮动窗口*/
    showpover : function(url, name, p) {
        /*清除 垃圾缓存键*/
        var keys = appcan.locStorage.keys();
        for (var i = 0; i < keys.length; i++) {
            if (keys[i].indexOf(b.cacheLeader) < 0)
                appcan.locStorage.remove(keys[i]);
        }
        /*********************************************/
        p = p || {};
        appcan.locStorage.setVal("showurlparams", b.j2s(p));
        appcan.window.openPopover({
            name : name || url.split(".")[0],
            url : url,
            type : p.windowType != null ? p.windowType : 0
        });
    },
    /*打开弹出窗口*/
    showframe : function(url, name, p, headerId, contentId) {
        p = p || {};
        appcan.locStorage.setVal("showurlparams", b.j2s(p));
        var titHeight = $('#' + (headerId || "header")).offset().height;
        appcan.frame.open(contentId || "content", url, 0, titHeight, name);
        window.onorientationchange = window.onresize = function() {
            appcan.frame.resize(contentId || "content", 0, titHeight);
        }
    },
    /*获取页面参数*/
    geturlparams : function() {
        var p = appcan.locStorage.getVal("showurlparams") || "{}";
        return b.s2j(p);
    },
    /*获取根目录*/
    getrootpath : function() {
        var url = window.location.href;
        var arr = url.split("winpage");
        if (arr.length > 1) {
            return arr[0];
        } else {
            var pagename = url.split("/");
            return url.split(pagename[pagename.length-1])[0];
        }
    },
    /* 关闭窗口 */
    close : function() {
        appcan.locStorage.remove("showurlparams");
        appcan.window.close(-1);
    },
    /* 关闭浮动窗口 */
    closepover : function() {
        appcan.window.closePopover();
    },
    /*圆圈包围的数字*/
    pt : function(t) {
        return b.fs(t, "xy-o");
    },
    /*获取字体样式*/
    fs : function(t, cs, s) {
        return "<div class='" + cs + "' " + (s || "") + ">" + t + "</div>";
    },
    /*设置节点为内容体*/
    setcontent : function(header, content, footer) {
        var bh = $("body").offset().height;
        var hh = $(header).offset().height;
        var fh = (footer == null ? 0 : $(footer).offset().height);
        var ct = $(content)[0];
        ct.style.height = (bh - hh - fh) + "px";
        ct.style.overflow = "auto";
    },
    /*单击事件[btn-act、ani-act]*/
    click : function(s, f, c) {
        appcan.button(s, c || "ani-act", function() {
            this.f = f;
            this.f();
        });
    },
    /*长按事件*/
    longclick : function(s, f) {
        $(s).on("longTap", function() {
            this.f = f;
            this.f();
        });
    },
    /*间断执行*/
    runlater : function(f, d) {
        var t = (d || 1000 );
        var a = setInterval(function() {
            f();
            clearInterval(a);
        }, t);
    },
    /*运行循环执行*/
    runcycle : function(f, d) {
        var t = (d || 100);
        var a = setInterval(function() {
            var s = f();
            if (s) {
                clearInterval(a);
            }
        }, t);
    },
    /*弹出浮动消息框*/
    alert : function(t, time) {
        appcan.window.openToast({
            msg : t,
            duration : time * 2000 || 3000,
            position : 5,
            type : 0
        });
    },

    /*获取当前页面跟目录*/
    getbasepath : function() {
        var jss = document.getElementsByTagName('script');
        for (var i = 0; i < jss.length; i++) {
            var src = jss[i].src;
            var srcs = src.split('js/appcan.js');
            if (srcs.length > 1) {
                return srcs[0];
            }
        };
    },
    /*设置全局监听*/
    setlistener : function(id, f) {
        var onNotification = f;
        uexWindow.onNotification = onNotification;
        uexWindow.subscribeChannelNotification(id, "onNotification");
    },
    /*执行全局监听*/
    runlistener : function(id, t) {
        uexWindow.publishChannelNotification(id, t);
    },
    /*获取设备操作系统名称*/
    getos : function() {
        return uexWidgetOne.platformName;
    },
    /*安卓实体键捕获*/
    androidkey : function(f, id, enable) {
        appcan.window.monitorKey({
            id : id || "0",
            enable : enable || "1",
            callback : function(id) {
                f();
            }
        });
    },
    /*重设弹动效果*/
    bounceType : 0,
    resetbounce : function() {
        uexWindow.resetBounceView(b.bounceType);
    },
    /*设置弹动效果*/
    bounce : function(p) {
        var bps = {
            pullToReloadText : "下拉刷新",
            releaseToReloadText : "释放立即刷新",
            loadingText : "正在刷新..."
        }
        uexWindow.setBounce(1);
        if (p.top) {
            bps.textColor = "#000000";
            uexWindow.notifyBounceEvent(0, 1);
            uexWindow.showBounceView(0, "#FFFFFF", 1);
            uexWindow.setBounceParams(0, b.j2s(bps));
        }
        if (p.bottom) {
            bps.textColor = "#000000";
            uexWindow.notifyBounceEvent(1, 1);
            uexWindow.showBounceView(1, "#FFFFFF", 1);
            uexWindow.setBounceParams(1, b.j2s(bps));
        }
        uexWindow.onBounceStateChange = function(t, state) {
            if (state == 2) {
                if (t == 0 && p.top) {
                    setTimeout(function() {
                        b.bounceType = 0;
                        p.top();
                    }, 100);
                }
                if (t == 1 && p.bottom) {
                    setTimeout(function() {
                        b.bounceType = 1;
                        p.bottom();
                    }, 100);
                }
            }
        }
    },
    /*获取时间简略格式*/
    sdatetime : function(type, str_now, str_date) {
        var str_nowDate = b.replace(str_now, "-", "/");
        var str_dateDate = b.replace(str_date, "-", "/");
        var dt_now = new Date(str_nowDate);
        var dt_date = new Date(str_dateDate);
        var int_minutes = parseInt((dt_now - dt_date) / 60000);
        var int_hours = (int_minutes / 60).toFixed(2);
        var int_days = int_minutes / 1440;
        if (int_days < 10) {
            var dt_now1 = new Date(str_nowDate.split(" ")[0]);
            var dt_date1 = new Date(str_dateDate.split(" ")[0]);
            int_days = (dt_now1 - dt_date1) / 86400000;
        }
        var fun_day_before = function() {
            if (int_days >= 1 && int_days < 2) {
                return "昨天";
            } else if (int_days >= 2 && int_days < 3) {
                return "前天";
            } else if (int_days >= 3 && int_days < 10) {
                return int_days + "天前";
            } else if (int_days >= 10) {
                if (dt_now.getFullYear() == dt_date.getFullYear()) {
                    return dt_date.getMonth() + 1 + "月" + dt_date.getDate() + "日";
                } else {
                    return str_date.split(" ")[0];
                }
            }
        }
        var fun_day_after = function() {
            int_days = -int_days;
            if (int_days >= 1 && int_days < 2) {
                return "明天";
            } else if (int_days >= 2 && int_days < 3) {
                return "后天";
            } else if (int_days >= 3 && int_days < 10) {
                return int_days + "天后";
            } else if (int_days >= 10) {
                if (dt_now.getFullYear() == dt_date.getFullYear()) {
                    return dt_date.getMonth() + 1 + "月" + dt_date.getDate() + "日";
                } else {
                    return str_date.split(" ")[0];
                }
            }
        }
        var fun_time_before = function() {
            if (int_minutes >= 0 && int_minutes < 5) {
                return "刚刚";
            } else if (int_minutes >= 5 && int_minutes < 60) {
                return int_minutes + "分钟前";
            } else if (int_hours >= 0 && int_hours < 24) {
                var _m = int_hours - parseInt(int_hours);
                return Math.floor(int_hours) + (_m >= 0.3 ? ".5" : "") + "小时前";
            } else if (int_hours >= 24) {
                return fun_day_before();
            }
        }
        var fun_time_after = function() {
            int_minutes = -int_minutes;
            int_hours = -int_hours;
            if (int_minutes >= 0 && int_minutes < 5) {
                return "刚刚";
            } else if (int_minutes >= 5 && int_minutes < 60) {
                return int_minutes + "分钟后";
            } else if (int_hours >= 0 && int_hours < 24) {
                var _m = int_hours - parseInt(int_hours);
                return Math.floor(int_hours) + (_m >= 0.3 ? ".5" : "") + "小时后";
            } else if (int_hours >= 24) {
                return fun_day_after();
            }
        }
        if (type == "date") {
            if (str_now == str_date) {
                return "今天";
            } else if (int_days > 0) {
                return fun_day_before();
            } else {
                return fun_day_after();
            }
        } else if (type == "datetime") {
            if (int_minutes > 0) {
                return fun_time_before();
            } else {
                return fun_time_after();
            }
        } else {
            return str_date;
        }
    },
    /*高德地图加偏*/
    gaodepos : function(lat, lng, f) {
        b.ajax("http://api.zdoz.net/transgps.aspx", {
            type : "GET",
            lat : lat,
            lng : lng
        }, function(state, d) {
            f({
                lng : d.Lng,
                lat : d.Lat
            });
        });
    },
    /*获取Url参数*/
    getUrlParam : function(name) {
        //构造一个含有目标参数的正则表达式对象
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        //匹配目标参数
        if (r != null) {
            return unescape(r[2]);
        } else {
            return null;
            //返回参数值
        }
    },
    /**
     * @desc 函数防抖---“立即执行版本” 和 “非立即执行版本” 的组合版本
     * @param func 需要执行的函数
     * @param wait 延迟执行时间（毫秒）
     * @param immediate---true 表立即执行，false 表非立即执行
     **/
    debounce : function(func, wait, immediate) {
        var timer;
        return function() {
            var context = this;
            var args = arguments;

            if (timer)
                clearTimeout(timer);
            if (immediate) {
                var callNow = !timer;
                timer = setTimeout(function() {
                    timer = null;
                }, wait)
                if (callNow)
                    func.apply(context, args)
            } else {
                timer = setTimeout(function() {
                    func.apply(context, args)
                }, wait);
            }
        }
    },
    /*设置只能输入数字和保留两位小数*/
    checkNum : function(obj) {
        if (obj.value.length > 10)
            obj.value = obj.value.slice(0, 10);

        /*清除“数字”和“.”以外的字符*/
        obj.value = obj.value.replace(/[^\d.]/g, "");
        /*只保留第一个. 清除多余的*/
        obj.value = obj.value.replace(/\.{2,}/g, ".");
        obj.value = obj.value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
        /*只能输入两个小数*/
        obj.value = obj.value.replace(/^(\-)*(\d+)\.(\d\d).*$/, '$1$2.$3');
        /*首位不能输入“.”*/
        obj.value = obj.value.replace(/^\./g, '');
        /*如果没有小数点，首位不能为0，如01、02...*/
        if (obj.value.indexOf(".") < 0 && obj.value != "") {
            obj.value = parseFloat(obj.value);
        }
    },
    /*factQrUrl厂家二维码url 获取标签编码*/
    getFactQrCode : function(factQrUrl) {
        //https://mobile.gasitrace.com/#/?189230004282
        //http://yongan.jtexplorer.com:8999/qrcode/index.html?number=T00126838
        var arrCode = factQrUrl.split('?');
        if (arrCode.length == 2) {
            var arrTag = arrCode[arrCode.length - 1].split('=');
            if (arrTag.length == 1)
                return arrTag[0];
            else
                return arrTag[arrTag.length - 1];
        } else {
            return factQrUrl;
        }
    },
    /**
     * @param {String} lat 纬度
     * @param {String} lng 经度
     * @param {Boolean} real 是否实时
     * @param {Function} func 回调方法
     */
    getAdressByPos : function(lat, lng, real, func) {
        var bornTime = b.lsget("qpAddrBornTime") || '0';
        var compareTime = new Date().getTime() - parseInt(bornTime);
        if (compareTime > 600000) {/*缓存超过10分钟后清除*/
            b.lsremove("qpAddr");
            b.lsremove("qpAddrBornTime");
        }

        var address = b.lsget("qpAddr") || "";
        if (real)/*获取实时地址时*/
            address = "";

        if (b.isnull(address)) {
            var pos = lat + "," + lng;
            b.ajax("https://api.map.baidu.com/reverse_geocoding/v3/?ak=ZAYTGcWgFaYyw5RIxBvbu4pGc7CXBfVI&output=json&coordtype=bd09ll&location=" + pos + "", {
            }, function(state, data) {
                if (state && data.status == 0) {
                    var rev_address = data.result.formatted_address;
                    b.lsset({
                        qpAddr : rev_address,
                        qpAddrBornTime : new Date().getTime()/*返回 日期 1970.01.01 距现在的毫秒数*/
                    });
                    if (func)
                        func(rev_address);
                }
            });
        } else {
            if (func)
                func(address);
        }
    }
}
