/*
 功能：基于APPCAN进行控件的封装(expand control)
 作者：FQQ
 日期：2016.02.03
 **/

/*封装扩展控件 Expand Control*/
var ec = {
    namespace : "ec",
    /*封装基于APPCAN select的下拉列表*/
    select : function(p) {

        /*控件中内部html dom对象集合*/
        var el = {};
        var sd;

        var setSelectValue = function(value) {
            for (var i = 0; i < el.select.options.length; i++) {
                if (el.select.options[i].value == value) {
                    el.select.options[i].selected = true;
                    el.selectText.innerHTML = el.select.options[i].text;
                    break;
                }
            }
        }
        /*整理下拉列表项*/
        var mel = function(data) {
            sd = data;
            /*构建列表HTML*/
            var html = '<div class="select uba bc-border bc-text"><div class="text">请选择</div><div class="icon"></div><select selectedindex="0">';
            for (var i = 0; i < data.length; i++) {
                html += "<option value='" + data[i][p.valueField] + "'>" + data[i][p.textField] + "</option>";
            }
            html += "</select></div>";
            $(p.selector)[0].innerHTML = html;

            /*列表选择事件*/
            appcan.select(p.selector, function(ele, value) {
                if (p.events && p.events.select) {
                    p.events.select(ele, value, data[ele[0].selectedIndex]);
                }
            });

            /*获取APPCAN控件的下拉SELECT和标题html dom对象*/
            el.selectText = $(p.selector)[0].getElementsByTagName("div")[1];
            el.select = $(p.selector)[0].getElementsByTagName("select")[0];

            /*设置默认值*/
            if (p.defaultValue) {
                setSelectValue(p.defaultValue);
            } else if (data.length > 0) {
                setSelectValue(data[0][p.valueField]);
            }
        }
        /*根据不同的数据请求方式分别处理*/
        if (p.dataType == "load") {
            b.ajax(pc.SIP + p.dataParams.dataPage, p.dataParams, function(state, data) {
                if (state == true) {
                    mel(data.dtData || data.data);
                }
                if (p.events && p.events.loaded) {
                    p.events.loaded(el, data);
                }
            });
        } else if (p.dataType == "local") {
            mel(p.data);
        }

        /*设置下拉列表的值*/
        this.setValue = function(value) {
            setSelectValue(value);
        }
        /*获取下拉列表的选中值*/
        this.getValue = function() {
            return el.select.value;
        }
        /*获取下拉列表的选中项集合*/
        this.getData = function() {
            return sd[el.select.selectedIndex];
        }
        return this;
    },
    /*封装基于APPCAN listview的下拉列表*/
    listview : function(p) {
        /*控件中内部html dom对象集合*/
        var listData = {};
        var eclv = this;
        var fb = ["id", "icon", "logo", "logoCss", "title", "describe", "note", "icontitle", "subTitle", "subDescribe", "subNote"];
        this.lvparams = {};
        for (var i in p) {
            this.lvparams[i] = p[i];
        }
        this.lvparams.data = null;
        var lv = listview(this.lvparams);
        /*列表事件绑定*/
        bindEvents = function() {
            lv.on("click", function(ele) {
                if (p.hasCheckbox) {
                    listData[ele.id].checked = $("[type=checkbox]", ele)[0].checked;
                }
                if (p.hasRadiobox) {
                    listData[ele.id].checked = $("[type=radio]", ele)[0].checked;
                }
                if (p.events && p.events.click) {
                    p.events.click(ele, listData[ele.id]);
                }
            });
            lv.on("expand", function(ele, exp) {
                var ld = listData[ele.id];
                if (ld.expEle == null) {
                    if (ld.expandType == "input") {
                        ld.expEle = $('<div class="xy-bd-blue uinput ub ub-f1"><input placeholder="" class="tx-c ' + ld.expandCss + '" ' + (ld.inputAttr || '') + ' value="' + (ld.subTitle || '') + '" type="' + ld.inputType + '" class="ub-f1 tx-c" /></div>');
                    } else if (ld.expandType == "textarea") {
                        ld.expEle = $('<div class="xy-bd-blue uinput ub ub-f1"><textarea id="'+ld.id+'" maxlength="'+ld.maxLength+'" placeholder="'+ld.placeholder+'" class="ub-f1 ' + ld.expandCss + '" ></textarea></div>');
                        $("textarea", ld.expEle).val(ld.subTitle);
                    }
                } else {
                    if (ld.expandType == "input") {
                        $("input", ld.expEle).val(ld.subTitle)
                    } else if (ld.expandType == "textarea") {
                        $("textarea", ld.expEle).val(ld.subTitle)
                    }
                }
                exp.append(ld.expEle);
                if (p.events.expand) {
                    p.events.expand(ele, exp[0], ld);
                }
            });
            lv.on("collapse", function(ele, exp) {
                var ld = listData[ele.id];
                if (ld.expandType == "input") {
                    var str_nvalue = $("input", ld.expEle).val();
                    $(".subTitle", ele).html(str_nvalue);
                    ld.subTitle = str_nvalue;
                } else if (ld.expandType == "textarea") {
                    var str_nvalue = $("textarea", ld.expEle).val();
                    $(".subTitle", ele).html(str_nvalue);
                    ld.subTitle = str_nvalue;
                }
                if (p.events.collapse) {
                    p.events.collapse(ele, exp[0], ld);
                }
            });
            lv.on("listClick", function(ele, listEl) {
                var ld = listData[ele.id];
                var v = listEl.getAttribute("value");
                var t = listEl.innerHTML;
                if (ld.listType != "button") {
                    eclv.setItem({
                        id : listData[ele.id].id,
                        listValue : v,
                        subTitle : t
                    });
                }
                if (p.events && p.events.listClick) {
                    p.events.listClick(ele, listData[ele.id], v, t);
                }
            });
            lv.on("longClick", function(ele) {
                if (p.events && p.events.longClick) {
                    p.events.longClick(ele, listData[ele.id]);
                }
            });
            lv.on("switchChange", function(ele, itemid, v) {
                listData[itemid].switchState = v;
                if (p.events && p.events.switchChange) {
                    p.events.switchChange(ele, listData[itemid], v);
                }
            });
            lv.on("checkboxChange", function(evt) {
                var itemid = b.gattr(this, 'itemid');
                listData[itemid].checked = this.checked;
                if (p.events && p.events.checkboxChange) {
                    p.events.checkboxChange(this, listData[itemid], this.checked);
                }
                listData[itemid].checked = this.checked;
            });
            lv.on("radioChange", function(evt) {
                var itemid = b.gattr(this, 'itemid');
                listData[itemid].checked = this.checked;
                if (p.events && p.events.radioChange) {
                    p.events.radioChange(this, listData[itemid], this.checked);
                }
            });
        }
        bindEvents();

        /*整理数据*/
        var makeData = function(data) {
            var array = [];
            var fe = [];
            /*整理列表项字段*/
            for (var i = 0; i < fb.length; i++) {
                fe.push(p[fb[i] + "Field"] || fb[i]);
            }
            /*循环取数，整理列表项数据*/
            for (var i = 0; i < data.length; i++) {
                var iv = data[i];
                iv.index = i;
                /*循环赋通用默认值*/
                if (p.defaults) {
                    for (var a in p.defaults) {
                        if (iv[a] == null) {
                            iv[a] = p.defaults[a];
                        }
                    }
                }
                /*循环赋值*/
                for (var f = 0; f < fb.length; f++) {
                    iv[fb[f]] = data[i][fe[f]];
                }
                /*设定列表项的开关按钮*/
                if (p.switchField && data[i][p.switchField] == "1") {
                    iv.switchBtn = {
                        value : (data[i][p.switchValueField] == "1" ? true : false),
                        mini : p.switchMini
                    };
                }
                if (iv.switchBtn) {
                    iv.switchState = iv.switchBtn.value || false;
                }
                listData["item" + iv.id] = iv;
                if (data[i].hasExpand && data[i].data) {
                    makeData(data[i].data);
                }
                array.push(iv);
            }
            return array;
        }
        /*根据不同的数据请求方式分别处理*/
        var loadData = function(add) {
            if (p.dataType == "load") {
                b.ajax(pc.SIP + p.dataParams.dataPage, p.dataParams, function(state, data) {
                    if (state == true) {
                        var ndata = makeData(data.dtData || data.data);
                        /*装载列表*/
                        if (add == true) {
                            lv.add(ndata);
                        } else {
                            lv.set(ndata);
                        }
                    }
                    if (p.events && p.events.loaded) {
                        p.events.loaded(ndata);
                    }
                });
            } else if (p.dataType == "local") {
                var ndata = makeData(p.data);
                /*装载列表*/
                if (add == true) {
                    lv.add(ndata);
                } else {
                    lv.set(ndata);
                }
            }
        }
        /*获取当前列表数据*/
        this.getData = function() {
            return listData;
        }
        /*装载列表项选项*/
        this.setItemList = function(id, listdata, or) {
            var data = listData["item" + id];
            if (or != false) {
                data.list = listdata;
            } else {
                if (data.list && data.list.length) {
                    for (var i = 0; i < listdata.length; i++) {
                        data.list.push(listdata[i]);
                    }
                }
            }
            lv.makeExpand(id, data, listdata, or);
        }
        /*设置开关值*/
        this.setSwitch = function(v, state) {
            if (appcan.isArray(v)) {
                for (var i = 0; i < v.length; i++) {
                    lv.setSwitch(v[i].id, state);
                }
            } else {
                lv.setSwitch(v, state);
            }
        }
        /*获取开关值*/
        this.getSwitch = function(v) {
            if (appcan.isArray(v)) {
                var ar = [];
                for (var i = 0; i < v.length; i++) {
                    v[i].switchState = lv.getSwitch(v[i]);
                }
            } else {
                return lv.getSwitch(v);
            }
        }
        /*设置制定项选中*/
        this.setChecked = function(state, pw) {
            var clist = $("[type=checkbox]", p.selector);
            var rlist = $("[type=radio]", p.selector);
            var f = function(d) {
                for (var i = 0; i < d.length; i++) {
                    var itemid = b.gattr(d[i], "itemid");
                    d[i].checked = pw(listData[itemid]) == true ? state : !state;
                }
            }
            f(clist);
            f(rlist);
        }
        /*获取复选框，单选框的选中项*/
        this.getChecked = function(state) {
            var a_true = [],
                a_false = [];
            var clist = $("[type=checkbox]", p.selector);
            var rlist = $("[type=radio]", p.selector);
            var f = function(d) {
                for (var i = 0; i < d.length; i++) {
                    var itemid = b.gattr(d[i], "itemid");
                    if (d[i].checked == true) {
                        a_true.push(listData[itemid]);
                    } else {
                        a_false.push(listData[itemid]);
                    }
                }
            }
            f(clist);
            f(rlist);
            return (state == false ? a_false : a_true);
        }
        /*修改某项的值（继承自appcan.listview）*/
        this.updateItem = function(el, name, value) {
            switch(name) {
            case "title":
                $(".lv_title", item).html(value);
                break;
            case "subTitle":
                $(".lv_subTitle", item).html(value);
                break;
            }
        }
        /*修改列表某项*/
        this.setItem = function(d) {
            var data = appcan.isArray(d) == false ? [d] : d;
            for (var i = 0; i < data.length; i++) {
                var dv = data[i];
                if (dv.id) {
                    var itemid = "item" + dv.id;
                    var el = $("#item" + dv.id, p.selector);
                    if (el && el.length > 0) {
                        /*修改HTML值*/
                        for (var vn = 4; vn < fb.length; vn++) {
                            if (dv[fb[vn]] != null) {
                                var z = fb[vn];
                                $("." + z, el).html(dv[p[z + "Field"] || z]);
                            }
                        }
                        /*修改单选框、复选框*/
                        if (dv.checked) {
                            $("[type=checkbox]", el).attr("checked", dv.checked);
                            $("[type=radio]", el).attr("checked", dv.checked);
                        }
                        /*修改开关*/
                        if (dv.switchState != null) {
                            this.setSwitch(dv.id, dv.switchState);
                        }
                        /*修改logo*/
                        this.setLogo(dv);
                        /*修改图标*/
                        if (dv[p.iconField || "icon"]) {
                            var iconel = $(".icon", el);
                            if (iconel && iconel.length > 0) {
                                iconel[0].style.backgroundImage = "url('" + dv[p.iconField || "icon"] + "')";
                            }
                        }
                        /*修改影藏值*/
                        for (var pv in dv) {
                            listData[itemid][pv] = dv[pv];
                        }
                    }
                }
            }
        };
        /*设置列表项Logo，传入JSON数组[{id:1,logo:''},{..}]*/
        this.setLogo = function(d) {
            var dt = appcan.isArray(d) ? d : [d];
            for (var i = 0; i < dt.length; i++) {
                var itemid = "item" + dt[i][p.idField || 'id'];
                var lel = $(".logo", $("#" + itemid, p.selector));
                if (lel && lel.length > 0) {
                    if (dt[i][p.logoField || 'logo']) {
                        var ocss = listData[itemid][p.logoField || 'logo'];
                        lel[0].className = lel[0].className.replace(ocss, dt[i][p.logoField || 'logo']);
                        listData[itemid].logo = dt[i][p.logoField || 'logo'];
                    }
                    if (dt[i][p.logoCssField || "logoCss"]) {
                        var ocss = listData[itemid]['logoCss'] || p.logoCss;
                        lel[0].className = lel[0].className.replace(ocss, dt[i][p.logoCssField || 'logoCss']);
                        listData[itemid].logoCss = dt[i][p.logoCssField || 'logoCss'];
                    }
                }
            }
        }
        /*获取列表项的值,指定ID值["2","3","5"]，返回[{id:'',title:''},{id:'',title:''}]*/
        this.getItem = function(v) {
            if (appcan.isArray(v)) {
                var a = [];
                for (var i = 0; i < v.length; i++) {
                    a.push(listData["item" + v[i]]);
                }
                return a;
            } else {
                return listData["item" + v];
            }
        }
        /*重新加载数据*/
        this.reload = function(d, add) {
            if (p.dataType == "load") {
                /*重新加载应该从第一页开始*/
                p.dataParams.start = 0;
                for (var i in d) {
                    p.dataParams[i] = d[i];
                    this.lvparams[i] = d[i];
                }
            } else if (p.dataType == "local") {
                p.data = d;
            }
            loadData(add);
        }
        /*翻页*/
        this.nextpage = function() {
            p.dataParams.start = p.dataParams.start + p.dataParams.limit;
            loadData(true);
        }
        /*添加项*/
        this.add = function(d) {
            p.data = d;
            loadData(true);
        }
        /*操作el节点*/
        this.doel = function(id, type) {
            var fun_do = function(_el, _id) {
                if (type == "del") {
                    _el.remove();
                    listData[_id] = null;
                } else if (type == "hide") {
                    _el.hide();
                    _el.removeClass("ub");
                } else if (type == "show") {
                    _el.show();
                    _el.addClass("ub");
                }
            }
            if (appcan.isArray(id)) {
                for (var i = 0; i < id.length; i++) {
                    fun_do($("#item" + id[i], p.selector), "item" + id[i]);
                }
            } else {
                fun_do($("#item" + id, p.selector), "item" + id);
            }
        }
        /*删除项*/
        this.del = function(id) {
            this.doel(id, "del");
        }
        /*影藏项*/
        this.hide = function(id) {
            this.doel(id, "hide");
        }
        /*显示项*/
        this.show = function(id) {
            this.doel(id, "show");
        }
        /*装载表单数据,如{id:'1',name:'lucy',no:'25325'}*/
        this.setFormValue = function(v) {
            for (var i in v) {
                var itemid = "item" + i;
                $(".subTitle", "#" + itemid).html(v[i]);
                listData[itemid].subTitle = v[i];
            }
        }
        /*获取表单数据，返回值如{id:'1',title:'one'}*/
        this.getFormValue = function() {
            var v = {};
            var items = $(".ubb");
            for (var i = 0; i < items.length; i++) {
                var f = items[i].id.split("item")[1];
                v[f] = $(".subTitle", items[i]).html();
            }
            return v;
        }
        /*将控件追加到页面上*/
        this.appendTo = function(obj) {
            lv.appendTo(obj);
        }
        /*初始化时加载数据*/
        loadData();
        /*返回列表对象*/
        return this;
    },
    /*封装了模版列表*/
    listtemp : function(p) {
        /*框架节点*/
        var frame = $("<div></div>");
        /*列表数据集合*/
        var listData = [];
        /*追加控件框架*/
        $(p.selector).append(frame);
        /*创建节点*/
        var makeTemp = function(dt, add) {
            if (add != true) {
                frame.html('');
                listData = [];
            }
            for (var i = 0; i < dt.length; i++) {
                var obj_item = p.temp(dt[i]);
                /*如果传入的是字符串则转换为EL节点*/
                var tel = typeof (obj_item) == "string" ? $(obj_item) : obj_item;
                var h = $('<div id="item_' + listData.length + '"></div>');
                h.append(tel);
                frame.append(h);
                listData.push(dt[i]);
                /*添加单击事件*/
                if (p.events && p.events.click) {
                    $(h).on("tap", function() {
                        var _id = this.id.split("_")[1];
                        p.events.click(this, listData[_id]);
                    });
                }
                /*添加长按事件*/
                if (p.events && p.events.longClick) {
                    $(h).on("longTap", function() {
                        var _id = this.id.split("_")[1];
                        p.events.longClick(this, listData[_id]);
                    });
                }
            }
        }
        /*根据不同的数据请求方式分别处理*/
        var loadData = function(add) {
            if (p.dataType == "load") {
                b.ajax(pc.SIP + p.dataParams.dataPage, p.dataParams, function(state, data) {
                    if (state == true) {
                        var dt = data.dtData || data.data || data.ListData;
                        makeTemp(dt, add);
                    }
                    if (p.events && p.events.loaded) {
                        p.events.loaded(dt,data);
                    }
                });
            } else if (p.dataType == "local") {
                makeTemp(p.data, add);
            }
        }
        /*重新加载数据*/
        this.reload = function(d) {
            if (p.dataType == "load") {
                /*重新加载应该从第一页开始*/
                p.dataParams.start = 0;
                if (d) {
                    for (var i in d) {
                        p.dataParams[i] = d[i];
                    }
                }
            } else if (p.dataType == "local") {
                if (d) {
                    p.data = d;
                }
            }
            loadData();
        }
        /*翻页*/
        this.nextpage = function() {
            p.dataParams.start = p.dataParams.start + p.dataParams.limit;
            loadData(true);
        }
        this.reload();
        /*返回列表对象*/
        return this;
    },
    /*封装网格布局*/
    gridview : function(p) {
        var d = p.data;
        /*拼接控件HTML*/
        var h = '<div class="ub ub-ver"><div class="ub ub-f1">';
        var c = function(t, i, b, index) {
            return '<div class="ub ub-f1 ub-ver grid-cell-bc ' + (index % 3 % 2 == 0 ? 'grid-cell-border' : 'grid-cell-center') + '" index="' + index + '"><div class="grid-cell ' + (p.cellCss || '') + '"><div class="grid-icon ub-img" style="background-image:url(' + i + ')"></div><div class="tx-c ulev-1 bc-text umar-t umar-b">' + t + '</div><div class="grid-o" style="display:' + ((b || 0) > 0 ? '' : 'none') + '">' + b + '</div></div></div>';
        }
        for (var i = 0; i < d.length; i++) {
            h += c(d[i].text, d[i].icon, d[i].badge, i);
            if ((i + 1) % 3 == 0 && i + 1 < d.length) {
                h += '</div><div class="ub ub-f1">';
            }
        }
        h += '</div></div>';
        $(p.selector)[0].innerHTML = h;
        var cs = $(".grid-cell-bc", p.selector);

        /*循环设置按钮项的单击事件*/
        for (var i = 0; i < cs.length; i++) {
            appcan.button(cs[i], "btn-act", function() {
                if (p.events && p.events.click) {
                    var idx = this.getAttribute("index");
                    p.events.click(this, d[idx], idx);
                }
            });
        }
        /*设置按钮项的消息数目*/
        this.badge = function(i, n) {
            var o = $(".grid-o", cs[i])[0];
            o.innerHTML = n;
            if (isNaN(n) == false) {
                o.style.width = "1.5em";
                o.style.display = ((n || 0) > 0 ? "" : "none");
            } else {
                o.style.width = "2em";
                o.style.display = "";
            }
        }
        return this;
    },
    /*图片列表控件*/
    imagelist : function(p) {
        var j = {},
            frame = $(p.selector)[0];
        var ftime = p.timeField || "time";
        var ftext = p.textField || "text";
        var fst = p.titleField || "title";
        var fsimg = p.imageField || "image";
        var freaded = p.readedField || "readed";
        /*追加类型*/
        var ctype = "over";
        /*根据不同的数据请求方式分别处理*/
        var loadData = function() {
            if (p.dataType == "load") {
                b.ajax(pc.SIP + p.dataParams.dataPage, p.dataParams, function(state, data) {
                    if (state == true) {
                        mel(data.dtData || data.data);
                    }
                    if (p.events && p.events.loaded) {
                        p.events.loaded(frame, data);
                    }
                });
            } else if (p.dataType == "local") {
                mel(p.data);
            }
        }
        /*图片框架HTML*/
        var f = function(title, text, time, image, readed) {
            var h_readed = readed == null ? '' : '<div class="ub ub-pc il-readed ' + (readed == true ? 'il-green' : 'il-red') + '">' + (readed == true ? '已读' : '未读') + '</div>';
            var h_img = (b.isnull(image) ? '' : '<div class="ub ub-img ub-ver" style="height:' + (p.height || "12em") + ';background-image:url(' + image + ')"></div>');
            return '<div class="ub ub-ver umar-a bc-bg il-frame"><div class="il-title ut-s">' + (title || '') + '</div><div class="il-dtime">' + (time || '') + '</div>' + h_img + '<div class="il-text">' + (text || '') + '</div><div class="il-line"></div><div class="ub ub-ac il-readall"><div class="ub-f1" style="color:black;">阅读全文</div>' + h_readed + '<div class="fa fa-angle-right fa-2x"></div></div></div>'
        }
        /*循环创建图片控件*/
        var mel = function(d) {
            /*如果是覆盖则需要删除之前的节点*/
            if (ctype == "over") {
                frame.innerHTML = "";
                j = {};
            }
            /*循环构建图片*/
            for (var i = 0; i < d.length; i++) {
                var idv = "id" + d[i][p.idField || "id"];
                var e = document.createElement("div");
                e.setAttribute("imageid", idv);
                /*如果是前面插入且子节点个数大于0时*/
                if (ctype == "insertBefore" && frame.childNodes.length > 0) {
                    frame.insertBefore(e, frame.childNodes[0]);
                } else {
                    frame.appendChild(e);
                }
                /*保存当前数据到JSON*/
                j[idv] = d[i];
                /*绑定单击事件*/
                appcan.button(e, "", function() {
                    if (p.events && p.events.click) {
                        var id = this.getAttribute("imageid");
                        p.events.click(this, j[id], id);
                    }
                });

                if (p.events && p.events.longClick) {
                    b.longclick(e, function() {
                        var id = this.getAttribute("imageid");
                        p.events.longClick(this, j[id], id);
                    });
                }
                var stitle = p.titleRender == null ? d[i][fst] : p.titleRender(d[i], d[i][fst]);
                var stime = p.timeRender == null ? d[i][ftime] : p.timeRender(d[i], d[i][ftime]);
                var stext = p.textRender == null ? d[i][ftext] : p.textRender(d[i], d[i][ftext]);
                var simg = p.imageRender == null ? d[i][fsimg] : p.imageRender(d[i], d[i][fsimg]);
                var sreaded = p.readedRender == null ? d[i][freaded] : p.readedRender(d[i], d[i][freaded]);
                e.innerHTML = f(stitle, stext, stime, simg, sreaded);
            }
        }
        /*重新加载*/
        this.reload = function(d, t) {
            if (p.dataType == "load") {
                for (var i in d) {
                    p.dataParams[i] = d[i];
                }
            } else if (p.dataType == "local") {
                p.data = d;
            }
            /*要么覆盖，要么追加（前追加后追加）*/
            ctype = t || "over";
            loadData();
        }
        /*翻页*/
        this.nextpage = function(t) {
            p.dataParams.start = p.dataParams.start + p.dataParams.limit;
            this.reload({}, t || "insertBefore");
        }
        /*初始化时加载数据*/
        loadData();
        /*返回列表对象*/
        return this;
    },
    /*页面信息栏控件*/
    infobar : function(p) {
        /*信息栏值*/
        var v = p.value || "";
        var h = '<div class="ub ibar-frame ' + (p.css || '') + '" ' + (p.backColor ? 'style="background-color:' + p.backColor + ';"' : '') + '><div class="ub umar-l umar-r"><div class="ub ub-ac fa ' + (p.leftIcon || '') + ' fa-1x ' + (p.leftIconCss || '') + '"></div></div><div class="ub ub-f1 ub-ac ibar-text ' + (p.textCss || '') + '">' + (p.defaultText || '') + '</div><div class="ub umar-l umar-r"><div class="ub ub-ac fa ' + (p.rightIcon || '') + ' fa-1x ' + (p.rightIconCss || '') + '"></div></div></div>';
        var e = $(p.selector)[0];
        e.innerHTML = h;
        var t = $(".ibar-text",e)[0];
        /*添加方法*/
        this.setText = function(val) {
            t.innerHTML = val;
        }
        this.getText = function() {
            return t.innerHTML;
        }
        this.setValue = function(val) {
            v = val;
        }
        this.getValue = function() {
            return v;
        }
        /*绑定单击事件*/
        appcan.button(e, "btn-act", function() {
            if (p.events && p.events.click) {
                p.events.click(e, v, t.innerHTML);
            }
        });
        /*返回对象*/
        return this;
    },
    /*工具栏*/
    toolbar : function(p) {
        var ele = $('<div class="ub ub-ac tb-frame sc-border-tab ' + (p.css || '') + '"></div>');
        $(p.selector).append(ele);
        var f = function(i, d) {
            var icon = '<div class="ub ub-pc fa ' + d.icon + ' tb-icon' + (p.noText == true ? '2 ' : ' ') + (d.iconCss || '') + '"></div>';
            var text = '<div class="ub ub-pc ub-ac tb-word' + (p.noIcon == true ? '2 ' : ' ') + (d.textCss || '') + '">' + d.text + '</div>';
            var h = $('<div id="id' + d.id + '" class="ub-f1 sc-text-active tb-item" style="' + (d.hide ? "display:none" : "") + '" index="' + i + '">' + (p.noIcon == true ? '' : icon) + (p.noText == true ? '' : text) + '</div>');
            b.click(h, function() {
                var index = b.gattr(this, "index");
                if (p.events && p.events.click) {
                    p.events.click(this, p.data[index], index);
                }
            });
            ele.append(h);
        }
        this.add = function(data) {
            for (var i = 0; i < data.length; i++) {
                f(i, data[i]);
            }
        }
        this.hide = function(id) {
            var ids = appcan.isArray(id) ? id : [id];
            for (var i = 0; i < ids.length; i++) {
                $("#id" + ids[i], ele).hide();
            }
        }
        this.show = function(id) {
            var ids = appcan.isArray(id) ? id : [id];
            for (var i = 0; i < ids.length; i++) {
                $("#id" + ids[i], ele).show();
            }
        }
        this.add(p.data);
        return this;
    },
    /*按钮列表栏、网格*/
    buttonlist : function(p) {
        var ele;
        if (p.type == "grid") {
            ele = null;
        } else {
            ele = $('<div class="ub ub-pc bl-rm' + (p.outerText ? '' : '1') + ' ' + (p.borderCss == null ? '' : p.borderCss) + '"></div>');
            $(p.selector).append(ele);
        }
        var rowCount = p.rowCount || 3;
        for (var i = 0; i < p.data.length; i++) {
            if (p.type == "grid" && i % rowCount == 0) {
                ele = $('<div class="ub bl-rm' + (p.outerText ? '' : '1') + '"></div>');
                $(p.selector).append(ele);
            }
            var icon = p.hasIcon ? '<div class="fa ' + p.data[i].icon + ' fa-' + (p.hasText && p.outerText != true ? '1' : '2') + 'x"></div>' : '';
            var text = p.hasText ? '<div class="ulev-1">' + p.data[i].text + '</div>' : '';
            var bcolor = p.noColor ? 'bl-btn-black' : ((p.data[i].colorCss || p.colorCss) || 'bc-btn');
            var sty = 'style="border-radius:' + (p.shapeType == null ? '1' : p.shapeType) + 'em;"';
            var badge = '<div style="display:' + (p.data[i].badge ? '' : 'none') + '" class="bl-badge">' + (p.data[i].badge || '') + '</div>';
            var btn;
            if (p.outerText) {
                btn = $('<div index=' + i + '><div class="ub ub-pc ub-ac ub-ver ' + bcolor + ' bl-btn" ' + sty + '>' + icon + badge + '</div><div class="ub ub-pc">' + text + '</div></div>');
            } else {
                btn = $('<div index=' + i + ' class="ub ub-pc ub-ac ub-ver ' + bcolor + ' bl-btn" ' + sty + '>' + icon + text + badge + '</div>');
            }
            if (p.type == "grid") {
                ele.append($('<div class="ub ub-f1 ub-pc"></div>').append(btn));
            } else {
                ele.append(btn);
            }
            b.click(btn, function() {
                var index = b.gattr(this, "index");
                if (p.events && p.events.click) {
                    p.events.click(this, p.data[index], index);
                }
            });
        }
        this.setBadge = function(index, num) {
            var btn = $(".bl-btn", ele)[index];
            var badge = $(".bl-badge", btn);
            badge.html(num);
            if (num > 0) {
                badge.show();
            } else {
                badge.hide();
            }
        }
        return this;
    },
    /*按钮工具栏*/
    buttonbar : function(p) {
        var el = $('<div class="ub sc-border-tab bb-frame ' + (p.hasCycle ? "bb-cycle" : "") + '" ' + (p.height ? 'style="height:' + p.height + 'em;"' : '') + '></div>');
        for (var i = 0; i < p.data.length; i++) {
            var bel = $('<div class="ub ub-ac ub-pc ub-f1 sc-border-tab sc-text-active bb-btn ' + (i == p.data.length - 1 ? (p.hasCycle ? 'bb-rra' : '') : '') + ' ' + (i == 0 ? (p.hasCycle ? 'bb-lra' : '') : 'bb-lb') + ' ' + ((p.data[i].selected && p.type == 'tab') ? 'bb-sc bb-sbc' : '') + '" index=' + i + '><div>' + p.data[i].text + '</div></div>');
            el.append(bel);
            /*选项卡模式*/
            if (p.type == "tab") {
                bel.on("tap", function() {
                    var index = b.gattr(this, "index");
                    if (p.signSelect) {
                        /*单选时一次只能选择一个，且无取消选择*/
                        var btns = el[0].childNodes;
                        for (var d = 0; d < btns.length; d++) {
                            p.data[d].selected = false;
                            btns[d].className = btns[d].className.replace("bb-sc bb-sbc", "");
                        }
                        p.data[index].selected = true;
                        this.className += " bb-sc bb-sbc";
                    } else {
                        /*多选时可以选择多个选中，且可取消选择*/
                        if (p.data[index].selected == true) {
                            p.data[index].selected = false;
                            this.className = this.className.replace("bb-sc bb-sbc", "");
                        } else {
                            p.data[index].selected = true;
                            this.className += " bb-sc bb-sbc";
                        }
                    }
                    if (p.events && p.events.click) {
                        p.events.click(this, p.data[index], index);
                    }
                });
            } else {
                /*按钮模式*/
                b.click(bel, function() {
                    var index = b.gattr(this, "index");
                    if (p.events && p.events.click) {
                        p.events.click(this, p.data[index], index);
                    }
                }, 'bb-sc');
            }
        }
        $(p.selector).append(el);
        /*获取选中项*/
        this.getSelected = function() {
            var s = [];
            for (var i = 0; i < p.data.length; i++) {
                if (p.data[i].selected == true) {
                    s.push(p.data[i]);
                }
            }
            return s;
        }
        /*设置选中项*/
        this.setSelected = function(a) {
            var dt = appcan.isArray(a) == true ? a : [a];
            var btns = el[0].childNodes;
            for (var d = 0; d < btns.length; d++) {
                p.data[d].selected = false;
                btns[d].className = btns[d].className.replace("bb-sc bb-sbc", "");
            }
            for (var i = 0; i < dt.length; i++) {
                for (var d = 0; d < btns.length; d++) {
                    if (dt[i] == p.data[d].id) {
                        p.data[d].selected = true;
                        btns[d].className += " bb-sc bb-sbc";
                    }
                }
            }
        }
        return this;
    },
    /*进度条*/
    progressbar : function(p) {
        var value = (p.value || 0);
        var bar = $('<div class="pbar-bar"></div>');
        var txt = $('<div class="ub ub-ac ub-pc pbar-num"></div>');
        var h = $('<div class="pbar-frame ub ub-f1"></div>');
        h.append(bar);
        h.append(txt);
        $(p.selector).append(h);
        bar[0].style.width = value + "%";
        txt.html(p.text || (p.value || 0) + "%");
        this.setValue = function(v) {
            if (v < 0) {
                v = 0;
            } else if (v > 100) {
                v = 100;
            }
            value = v;
            bar[0].style.width = v + "%";
            txt.html(v + "%");
        }
        this.setText = function(t) {
            txt.html(t);
        }
        this.getValue = function() {
            return parseInt(value);
        }
        return this;
    },
    /*弹窗窗口*/
    window : function(p) {
        var bc = document.createElement("div");
        var f = document.createElement("div");
        var u = document.createElement("div");
        bc.className = "win-back";
        f.className = "ub ub-ac ub-pc win-frame ";
        u.className = "ub ub-f1 ub-ver win-unit ";
        u.style.height = p.height || "20em";
        f.appendChild(u);
        $(u).append($('<div class="ub ub-ac bc-head bc-text-head win-title"><div class="ut ub-f1 ulev-3 ut-s tx-c">' + (p.title || '') + '</div></div>'));
        this.body = $('<div class="ub ub-f1 win-body"></div>');
        this.inner = $('<div class="ub-f1"></div>');
        if ( typeof (p.items) == "string") {
            this.inner.html(p.items);
        } else if ( typeof (p.items) == "object") {
            if (p.items.namespace && p.items.namespace == "ec") {
                p.items.appendTo(this.inner);
            } else {
                this.inner.append(p.items);
            }
        }
        $(u).append(this.body);
        this.body.append(this.inner);
        if (p.buttons && p.buttons.length > 0) {
            var btns = $('<div class="ub ub-pj "></div>');
            $(u).append(btns);
            for (var i = 0; i < p.buttons.length; i++) {
                var btn = $('<div class="ub ub-ac ub-f1 ub-pc btn bc-btn bc-text-head ' + (p.buttons[i].css || (i % 2 == 0 ? '' : 'xy-bc-orange')) + '" index="' + i + '">' + p.buttons[i].text + '</div>');
                btns.append(btn);
                appcan.button(btn, "btn-act", function() {
                    var index = b.gattr(this, "index");
                    if (p.events && p.events.click) {
                        p.events.click(this, p.buttons[index], index);
                    }
                });
            }
        }
        this.create = false;
        this.close = function() {
            this.create = false;
            document.body.removeChild(bc);
            document.body.removeChild(f);
        }
        this.hide = function() {
            f.className = "";
            f.style.display = "none";
            bc.style.display = "none";
        }
        this.show = function() {
            if (this.create == false) {
                document.body.appendChild(bc);
                document.body.appendChild(f);
                this.create = true;
            }
            f.className = "ub ub-ac ub-pc win-frame ";
            f.style.display = "";
            bc.style.display = "";
        }
        return this;
    },
    /*页面表头菜单*/
    headermenu : function(p) {
        var hm = this;
        this.state = "hide";
        var headerHeight = $(p.header).offset().height;
        var div_back = $('<div class="xy-hm-bc" style="display:none;"></div>');
        div_back[0].style.top = headerHeight + "px";
        div_back[0].style.height = ($(document.body).offset().height - headerHeight) + "px";
        document.body.appendChild(div_back[0]);
        var div_menuframe = $('<div class="ub"></div>');
        document.body.appendChild(div_menuframe[0]);
        div_menuframe[0].style.top = headerHeight + "px";
        if (p.align == "right") {
            var div_menunull = $('<div class="ub ub-f1"></div>');
            div_menuframe.append(div_menunull);
        }
        var div_menu = $('<div class="" style="display:none;"></div>');
        div_menuframe.append(div_menu);
        div_back.on("tap", function() {
            hm.hide();
        });
        div_menuframe.on("tap", function() {
            hm.hide();
        });
        if (p.width) {
            div_menu[0].style.width = p.width;
        }
        for (var i = 0; i < p.data.length; i++) {
            var item = $('<div class="ub sc-border-tab xy-hm-listitem ' + (i == p.data.length - 1 ? '' : 'xy-hm-listitem-line') + '" index=' + i + '><div class="ub ub-ac fa ' + p.data[i].icon + ' xy-hm-listicon ' + (p.data[i].iconCss || p.iconCss  ) + '" style="font-size:' + (p.iconSize || 1) + 'em;"></div><div class="ub ub-f1 ub-ac">' + p.data[i].text + '</div></div>');
            appcan.button(item, "bc-head", function() {
                hm.hide();
                if (p.events && p.events.click) {
                    var index = b.gattr(this, "index");
                    p.events.click(this, p.data[index], index);
                }
            });
            div_menu.append(item);
        }
        this.show = function() {
            this.state = "show";
            div_menu[0].className = "ub ub-ver ub-pe xy-hm-list sc-border-tab";
            div_back[0].style.display = "";
            div_menu[0].style.display = "";
        }
        this.hide = function() {
            this.state = "hide";
            div_menu[0].className = "";
            div_back[0].style.display = "none";
            div_menu[0].style.display = "none";
        }
        return this;
    },
    /*封装grid控件*/
    grid : function(p) {
        var fel = $('<div class="ubt bc-border sc-bg"></div>');
        var tel = $('<table class="xy-grid-table"></table>');
        var hh = '';
        for (var i = 0; i < p.header.length; i++) {
            hh += '<td class="sc-border-tab">' + p.header[i].text + '</td>';
        }
        var thel = $('<thead><tr>' + hh + '</tr></thead>');
        var tbel = $('<tbody></tbody>');
        var makeList = function(data) {
            var bh = '';
            for (var i = 0; i < data.length; i++) {
                bh += '<tr index="' + i + '">';
                for (var a = 0; a < p.header.length; a++) {
                    bh += '<td class="sc-border-tab">' + data[i][p.header[a].field] + '</td>';
                }
                bh += '</tr>';
            }
            tbel.html(bh);
            $("tr", tbel).on("tap", function() {
                var idx = this.getAttribute("index");
                if (p.events && p.events.rowClick) {
                    p.events.rowClick(data[idx]);
                }
                $(this).removeClass("sc-bg-active");
            });
            $("tr", tbel).on(b.isWindows() ? 'mousedown' : 'touchstart', function(evt) {
                var trel = this;
                $(this).addClass("sc-bg-active");
                setTimeout(function() {
                    $(trel).removeClass("sc-bg-active");
                }, 300);
            });
        }
        var loadData = function() {
            b.ajax(pc.SIP + p.dataParams.dataPage, p.dataParams, function(state, data) {
                if (state == true) {
                    makeList(data.dtData || data.data);
                }
                if (p.events && p.events.loaded) {
                    p.events.loaded(data);
                }
            });
        }
        if (p.dataType == "load") {
            loadData();
        } else {
            makeList(p.data);
        }
        this.reload = function(d) {
            for (var i in d) {
                p.dataParams[i] = d[i];
            }
            loadData();
        }
        tel.append(thel);
        tel.append(tbel);
        $(p.selector).append(tel);
        return this;
    },
    /*封装基于APPCAN checkbox的下拉列表*/
    checkbox : function(id, text) {
        var h = '<div class="uinn"><div class="ub"><div class="ub ub-rev ub-ac checkbox umar-r"><input type="checkbox" class="uabs ub-con umar-l" /></div><div class="ub ub-ac umar-l ub-f1">' + text + '</div></div></div>';
        $(id)[0].innerHTML = h;
        var f = $(".uinn",id)[0];
        var c = $("input",id)[0];
        f.onclick = function() {
            c.checked = !c.checked;
        }
        this.getValue = function() {
            return c.checked;
        }
        this.setValue = function(v) {
            c.checked = v;
        }
        /*返回对象*/
        return this;
    },
    /*封装评论控件*/
    comment : function(p) {
        var str_url = pc.SIP;
        var me = this,
            submiting = false, /*正在提交标记*/
            bsData = {}, /*业务数据对象*/
            str_reBsId = 0, /*被回复消息ID*/
            str_reUserId = 0, /*被回复用户ID*/
            el_frame = null, /*框架EL*/
            el_rbtemp = null, /*回复输入框模块EL*/
            el_textarea = null,
            str_pushobjIds = "",
            str_pushobjNames = "",
            el_pushobjLabel = null,
            selectpush = null;

        /*定义一个推送对象*/
        selectpush = new ecbs.selectpush({
            pagename : p.windowName,
            framename : p.frameName,
            events : {
                selected : function(obj, ids, name) {
                    str_pushobjIds = ids;
                    str_pushobjNames = name;
                    el_pushobjLabel.html(name);
                }
            }
        });

        /*设置业务数据*/
        this.setBsData = function(d) {
            bsData = d;
        }
        /*初始化控件时创建模块基础控件*/
        var fun_makeframe = function() {
            var html = '<div>';
            html += '<div class="ub cm-replyhd">';
            html += '<div class="ub-f1"></div>';
            html += '<div class="fa fa-comment-o cm-replybtn"></div>';
            html += '</div>';
            html += '<div class="cm-list"></div>';
            html += '<div class="cm-retemp" style="display:none;">';
            html += '<div class="uinput ub xy-bd-gray">';
            html += '<textarea placeholder="输入回复内容" class="cm-text">';
            html += '</textarea>';
            html += '</div>';
            html += '<div class="ub cm-pushobj"><div>推送给：</div><div class="cm-pushobj-users ub-f1"></div></div>';
            html += '<div class="ub">';
            html += '<div class="ub-f1 cm-btn">回复</div>';
            html += '<div class="ub-f1 cm-btn">刷新</div>';
            html += '</div>';
            html += '</div>';
            html += '</div>';
            el_frame = $(p.selector).html(html);
            el_rbtemp = $(".cm-retemp", el_frame);
            el_textarea = $("textarea", el_frame)[0];
            el_pushobjLabel = $(".cm-pushobj-users", el_frame);
            $('.cm-replybtn', p.selector).on('tap', function() {
                el_textarea.placeholder = "输入回复内容";
                str_reUserId = 0;
                str_reBsId = 0;
                el_rbtemp.show();
                setTimeout(function() {
                    el_textarea.focus();
                }, 500);
            });
            $('.cm-btn', p.selector).on('tap', function() {
                if (this.innerHTML == "回复") {
                    me.submit();
                } else {
                    me.load();
                }
            });
            $('.cm-pushobj', p.selector).on('tap', function() {
                selectpush.show();
            });
        }
        /*数据处理*/
        var fun_dealCommentData = function(dt, has) {
            var html = '';
            /*创建HTML节点*/
            for (var i = 0; i < dt.length; i++) {
                html += fun_makeCommentInfo(dt[i]);
            }
            $('.cm-list', p.selector).html(html);
            $('.cm-name', p.selector).on('tap', function() {
                var btnid = this.getAttribute('btnid');
                var bsid = this.getAttribute('bsid');
                str_reUserId = btnid;
                str_reBsId = bsid;
                el_textarea.placeholder = "回复" + this.innerHTML;
                el_rbtemp.show();
                setTimeout(function() {
                    el_textarea.focus();
                }, 200);
            });
        }
        /*创建任务评论标签*/
        var fun_makeCommentInfo = function(dt) {
            var str_id = dt.ID;
            var str_parentid = dt.I_ID_PARENT;
            var str_name = dt.VC_USERNAME;
            var str_date = dt.DT_WRITE;
            var str_text = dt.NVC_TEXT;
            var str_date = b.sdatetime("datetime", b.nowdatetime(), str_date);
            var h = '<div class="cm-frame">';
            h += '<div id="id_item_' + str_id + '">';
            h += '<div class="ub ub-pj">';
            h += '<div>';
            h += '<div class="cm-name" bsid="' + str_id + '" btnid="' + dt.I_ID_USER + '">' + str_name + '</div>';
            if (dt.VC_RBUSERNAME) {
                h += '<div class="xy-fc-gray" style="float:left">回复</div>';
                h += '<div class="cm-name" bsid="' + str_id + '" btnid="' + dt.I_ID_REUSER + '">' + dt.VC_RBUSERNAME + '</div>';
            }
            h += '：' + b.text2html(str_text) + '<label style="color:#0080FF;">' + (dt.NVC_PUSHOBJ || "") + '</label>';
            h += '</div>';
            h += '</div>';
            h += '</div>';
            h += '<div id="id_comment_item' + str_id + '"></div>';
            h += '</div>';
            return h;
        }
        /*从新装载数据*/
        this.load = function() {
            b.ajax(str_url, {
                action : "Task.GetCommentInfo",
                str_tableName : p.tableName,
                str_bsId : p.bsId
            }, function(state, data) {
                if (p.events && p.events.loaded) {
                    p.events.loaded(state, data);
                }
                if (state == true) {
                    $('.cm-list', p.selector).html('');
                    fun_dealCommentData(data.data, {});
                }
            });
        }
        /*发送推送消息*/
        var sendPushMsg = function(table, id, no, title) {
            if (str_pushobjIds.length > 0) {
                selectpush.send({
                    tableName : table, /*设置业务表名*/
                    bsid : id, /*设置业务ID*/
                    bsNo : "", /*设置业务编号*/
                    title : "日志回复信息", /*设置推送消息标题（一般是业务模块名称）*/
                    params : "page:winpage_logreport_logread,taskLogId:" + id, /*设置推送参数，主要是打开对应业务模块的JPUSH推送参数（参见INDEX.HTML）*/
                    pushText : login.userName + "在日志【" + title + "】回复中通知了你"/*设置推送消息*/
                });
                el_pushobjLabel.html('');
                str_pushobjIds = "";
                str_pushobjNames = "";
            }
        }
        /*提交保存评论回复*/
        this.submit = function() {
            var str_title = '';
            var str_value = el_textarea.value;
            if (b.trim(str_value).length == 0) {
                b.alert('回复内容不能为空');
                el_textarea.value = '';
                return;
            }
            str_value = (str_value);
            if (str_value.length > 500) {
                b.alert('回复内容过多');
                return;
            }

            if (b.isin(bsData.NVC_TYPE, ['日', '周', '月'])) {
                str_title = bsData.DT_WRITE + bsData.NVC_TYPE + '总结'
            } else {
                str_title = bsData.NVC_TITLE;
            }
            if (submiting) {
                b.alert('正在提交，请稍后...');
                return;
            }
            submiting = true;
            el_textarea.blur();
            var json = {
                action : "Task.SaveCommentInfo",
                str_tableName : p.tableName,
                str_bsId : p.bsId,

                str_bsUserId : bsData.I_ID_USER,
                str_bsNo : bsData.VC_NO || '',
                str_bsTitle : str_title,
                str_reuserId : str_reUserId,
                str_pushObj : str_pushobjNames,

                str_replyId : str_reBsId,
                str_text : str_value,
                str_bunitId : login.bigUnitId,
                str_unitId : login.unitId,
                str_userId : login.userId,
                str_userName : login.userName
            };
            b.ajax(str_url, json, function(state, data) {
                submiting = false;
                if (state && data.success) {
                    me.load();
                    el_textarea.placeholder = "输入回复内容";
                    str_reUserId = 0;
                    str_reBsId = 0;
                    el_textarea.value = "";

                    b.alert('回复成功');
                    el_rbtemp.hide();

                    /*发送推送消息*/
                    json.action = "Task.PushCommentMsg";

                    b.ajax(str_url, json, function(state, data) {
                        if (state && !data.success) {
                            b.alert('未能发出通知');
                        } else {
                            sendPushMsg(p.tableName, p.bsId, bsData.VC_NO || '', str_title);
                        }
                    });
                } else {
                    b.alert('回复');
                }
            });
        }
        fun_makeframe();
        return this;
    }
}

