/*
 功能：APP升级管理页面
 作者：冯巧巧
 日期：2017.07.26
 * */
var appupdate = {
    /*下载页面名称*/
    pagename : "",
    /*监听刷新时间间隔(s秒)*/
    refreshTime : 60,
    /*当前版本号*/
    version : '',
    /*最新版本信息*/
    lastVersionData : {},
    /*APP更新地址信息*/
    updateUrl : "",
    /*APP安装包文件存在路径*/
    appSavePath : "",
    /*当前版本是否需要更新*/
    needUpdate : false,

    /*获取版本信息*/
    getVersionInfo : function() {
        var me = this;
        /*获取设备平台*/
        var str_getos = b.getos().toUpperCase();

        /*当前APP版本号*/
        if (str_getos == "ANDROID") {
            me.version = pc.android.version;
        } else if (str_getos == "IOS") {
            me.version = pc.ios.version;
        }
        /*获取版本信息*/
        b.ajax(pc.SIP+ "Qp_About/GetestVersionNo", {  
              type:"GET",
              str_getos : str_getos            
        }, function(state, data) {
            /*是否需要更新*/
            if (state == true && data) {
                me.isUpdate(data);
            }
        });
    },

    /*检查版本是否需要更新*/
    checkNeedUpdate : function() {
        var ver = this.version.split('.');
        var last = this.lastVersionData.VC_VERNO.split('.');
        if (parseInt(last[0]) > parseInt(ver[0])) {
            return true;
        } else if (parseInt(last[0]) == parseInt(ver[0])) {
            if (parseInt(last[1]) > parseInt(ver[1])) {
                return true;
            } else if (parseInt(last[1]) == parseInt(ver[1])) {
                if (parseInt(last[2]) > parseInt(ver[2])) {
                    return true;
                }
            }
        }
        return false;
    },

    /*是否需要更新*/
    isUpdate : function(data) {
        /*data:版本信息 ,data1：是否检查更新*/
        var bool_checkUpdate = (data.data1[0].VC_VALUE == "1");

        /*整理下载地址*/
        if (data.data2) {
            var dt = data.data2;
            var os = b.getos().toUpperCase();
            for (var i = 0; i < dt.length; i++) {
                if (dt[i].VC_SYS.toUpperCase() == os) {
                    this.updateUrl = dt[i].VC_URL;
                    break;
                }
            };
        }

        /*整理版本信息*/
        if (data.data && bool_checkUpdate) {
            this.lastVersionData = data.data;

            /*是否强制更新*/
            var bool_ismust = (this.lastVersionData.I_MUST == 1);

            /*更新说明*/
            var str_remark = this.lastVersionData.VC_REMARK;

            /*设置下载文件路径*/
            this.appSavePath = "wgt://Download/apppackage" + this.lastVersionData.VC_VERNO + ".apk";

            /*设定当前版本是否需要更新*/
            this.needUpdate = this.checkNeedUpdate();

            /*设置缓存*/
            b.lsset({
                appupdate_needUpdate : this.needUpdate,
                appupdate_version : this.lastVersionData.VC_VERNO,
                appupdate_pagename : this.pagename,
                appupdate_remark : b.ifnull(str_remark, "暂无该版本功能介绍信息"),
                appupdate_must : bool_ismust,
                appupdate_url : this.updateUrl,
                versioninfo : b.j2s(this.lastVersionData)
            });

            /*如果当前版本号*/
            if (this.needUpdate) {
                if (bool_ismust == true) {
                    /*强制更新*/
                    this.showUpdateAlert();
                } else {
                    /*非强制更新，提示框一天只弹出一次*/
                    if (b.nowdatetime("date") != b.lsget("updateTipDate")) {
                        this.showUpdateAlert();
                    }
                }
            }
        }
    },

    /*显示更新提示信息*/
    showUpdateAlert : function() {
        appcan.window.open({
            name : "winage_public_update",
            dataType : 0,
            aniId : 0,
            type : 256,
            data : "winpage/public/update.html"
        });
    },

    /*安装APP更新包*/
    setupApp : function() {
        var me = this;
        /*如果相关基础信息不存在的时候就重新获取基础数据*/
        if (me.appSavePath == "") {
            me.getVersionInfo();
            setTimeout(function() {
                me.setupApp();
            }, 5000);
            return;
        }
        uexFileMgr.isFileExistByPath(1, me.appSavePath);
    },

    /*安装APP*/
    installApp : function() {
        uexWidget.installApp(this.appSavePath);
    },

    /*初始化文件管理器*/
    initFileMgr : function() {
        var me = this;
        uexFileMgr.cbIsFileExistByPath = function(opId, dataType, data) {
            if (data == 0) {
                me.downLoadApp();
            } else if (data == 1) {
                b.escript('winage_public_update', 'fun_updatePercent(100)');
            } else {
                alert(data);
            }
        }
        uexFileMgr.cbDeleteFileByPath = function(opId, dataType, data) {
            if (data == 0) {
                /*删除成功*/
            } else {
                /*删除失败*/
            }
        }
    },

    /*初始化下载器*/
    initLoaderMgr : function() {
        var me = this;
        /*回调下载状态监听*/
        uexDownloaderMgr.onStatus = function(opCode, fileSize, percent, status, savePath) {
            switch (status) {
            case 0:
                b.escript('winage_public_update', 'fun_updatePercent(' + percent + ')');
                break;
            case 1:
                b.escript('winage_public_update', 'fun_updatePercent(' + 100 + ')');
                setTimeout(function() {
                    uexDownloaderMgr.closeDownloader(opCode);
                }, 500);
                break;
            case 2:
                b.escript('winage_public_update', 'fun_downLoadFailure()');
                setTimeout(function() {
                    uexDownloaderMgr.closeDownloader(opCode);
                    uexFileMgr.deleteFileByPath(me.appSavePath);
                }, 500);
                break;
            }
        }
    },

    /*下载APP文件*/
    downLoadApp : function() {
        var me = this;
        var str_id = me.lastVersionData.ID;
        /*创建下载对象*/
        uexDownloaderMgr.createDownloader(str_id);
        /*开始下载文件*/
        uexDownloaderMgr.download(str_id, me.updateUrl, me.appSavePath, 1);
    },

    /*重新下载*/
    redownLoadApp : function() {
        var me = this;
        uexFileMgr.deleteFileByPath(me.appSavePath);
        setTimeout(function() {
            me.downLoadApp();
        }, 1000);
    },

    /*初始化APP更新器*/
    init : function(p) {
        var me = this;
        for (var i in p) {
            me[i] = p[i];
        }

        /*初始化文件管理器*/
        me.initFileMgr();

        /*初始化下载器*/
        me.initLoaderMgr();

        /*最新版本信息*/
        me.getVersionInfo();

        /*定时刷新获取最新版本的信息*/
        b.runcycle(function() {
            me.getVersionInfo();
        }, me.refreshTime * 1000);
    }
}
