/*
 功能：APP登录信息
 作者：FQQ
 日期：2017.03.07
 */

var login = {
    applogininfo : {},
    userId : 0, /*用户ID*/
    licid : 0, /*机构ID*/
    roles : "", /*角色(1充气员,2仓管员,3配送员),多个角色之间用英文逗号分隔*/
    userName : "", /*用户名称*/
    userPhone : "", /*电话*/
    userEmail : "", /*邮箱*/
    userUnit : "", /*单位*/
    loginAccount : "", /*用户账户*/
    loginPassword : "", /*用户密码*/
    loginDate : "", /*登录日期*/
    loginTime : "", /*登录时间*/
    orgId : 0, /*部门ID*/
    SystemParams : {}, /*登录信息*/

    /*初始化用户帐户对象*/
    initLogin : function() {
        this.applogininfo = {};
        this.userId = 0;
        this.licid = 0;
        this.roles = "";
        this.userName = "";
        this.userPhone = "";
        this.userEmail = "";
        this.userUnit="";
        this.userAccount = "";
        this.userPassword = "";
        this.loginDate = "";
        this.loginTime = "";
        this.orgId = 0;
    },

    /*后台获取系统参数信息*/
    loadSystemParams : function() {
        b.ajax(pc.SIP + "Qp_Login/GetParams", {
            type:"GET"
        }, function(state, data) {
            var data = data.data;
            if (data != null) {
                var params = {};
                for (var i = 0; i < data.length; i++) {
                    params[data[i].VC_NO] = data[i].VC_VALUE;
                };
                b.lsset({
                    "xyFrameworkSystemParams" : b.j2s(params)
                });
            }
        });
    },

    /*初始化系统参数*/
    initSystemParams : function() {
        var Params = b.lsget("xyFrameworkSystemParams");
        login.SystemParams = b.s2j(Params);
    },

    /*保存用户帐户信息到缓存*/
    setLogin : function(v) {
        /*写入缓存*/
        b.lsset({
            "xyFrameworkAppLogin" : v
        });
    },
    /*清除用户帐户信息*/
    clearLogin : function() {
        this.initLogin();
        this.setLogin("");
    },
    /*获取用户帐户信息*/
    getLogin : function() {
        this.initLogin();
        var lv = b.lsget("xyFrameworkAppLogin");
        if (b.isnull(lv) == false) {
            var json = b.s2j(lv);
            for (var i in json) {
                login[i] = json[i];
            }
        }
    },

    /*根据组织机构设置token*/
    loadUserToken : function(orgId, f) {
        b.lsset({
            "loginOrgId" : orgId
        });
        b.ajax(pc.SIP, {
            action : "Login.InitUserLoginInfo",
            str_userId : b.ifnull(login.userId, "0"),
            int_unitId : orgId/*组织机构ID*/
        }, function(state, data) {
            if (data.success) {
                /*获取用户权限信息*/
                var lv = {
                    userId : login.userId,
                    userNo : login.userNo,
                    userName : login.userName,
                    allUnitName : login.allUnitName,
                    loginAccount : login.loginAccount,
                    loginPassword : login.loginPassword,
                    orgId : orgId,
                    usertoken : data.value
                };
                /*写入登录信息到缓存*/
                login.setLogin(lv);
                if (f) {
                    f();
                }
            }
        });
    },
    getLoginUrl : function() {
        /*获取登录页面路径*/
        var filename = location.href;
        filename = filename.substr(filename.indexOf('widget/'));
        var arr = [filename.split("/")];
        var str_path = "";
        if (filename.indexOf("index.html") > 0 && filename.indexOf("login.html") > 0) {
            str_path = "false";
        } else {
            for (var i = 0; i < arr[0].length - 2; i++) {
                str_path += "../";
            };
            str_path = str_path + "login.html";
        }
        return str_path;
    },

    /*获取登录信息*/
    loadLoginInfo : function(account, pwd, f) {
        var me = this;        
        b.ajax(pc.SIP + "Qp_Login/Getlogin", {
            str_useraccount : account,
            str_password : pwd,
            type : 'GET'
        }, function(state, v) {
            if (v.success == true) {
                var data = eval('(' + v.apploginfo + ')');
                /*获取用户权限信息*/
                var lv = {
                    LoginToken : data.LoginToken,
                    userId : data.userid,
                    licid : data.licid,
                    userName : data.username,
                    userPhone : data.userphone,
                    userEmail : data.useremail,
                    userUnit: data.orggroupname,
                    loginAccount : account,
                    loginPassword : pwd,
                    roles : data.data //角色
                };
                /*写入登录信息到缓存*/
                me.setLogin(lv);
                /*设置登录信息login变量*/
                me.getLogin();
            }
            if (f) {
                f(state, v);
            }
        }, false);
    },
    /*验证用户是否禁用或删除*/
    CheckUserDisable : function() {
        setTimeout(function() {
            uexWidget.onResume = resumeFun;
        }, 200);
        function resumeFun() {
            var str_loginurl = login.getLoginUrl();
            if (str_loginurl != "false") {

                try {
                    b.ajax(pc.SIP, {
                        action : "Home.CheckUserDisable",
                        str_userId : login.userId
                    }, function(state, data) {
                        if (data.success == false) {
                            appcan.window.alert({
                                content : "该用户已被禁用或删除",
                                callback : function(err, dt, dataType, optId) {
                                    b.lsremove('str_timeType');

                                    /*清空登录信息*/
                                    login.clearLogin();
                                    /*取消极光推送别名*/
                                    //pc.JPush.clearAlias();
                                    /*清除所有推送通知*/
                                    //pc.JPush.clearMsg();
                                    /*返回登录界面*/
                                    b.show(str_loginurl, "login", {
                                        aniId : 0
                                    });
                                    setTimeout(function() {
                                        b.close();
                                    }, 1000);
                                }
                            });
                            return;
                        }
                    });

                } catch(e) {
                    alert(e);

                }
            }
        }

    }
}

/*初始化登录*/
login.initLogin();

/*初始化系统参数*/
login.initSystemParams();

/*获取登录信息*/
login.getLogin();
/*验证用户是否禁用或删除*/
//login.CheckUserDisable();
