/*
 功能：APPCAN Native插件封装
 作者：FQQ
 日期：2016.02.14
 **/

var uec = {
    namespace : "uec",
    /**********设备信息插件*********/
    /*获取设备信息[type:获取设备信息类型，f：获取参数后回调函数]*/
    device : function() {
        /*设备回调显示设备相关信息*/
        this.getInfo = function(type, f) {
            uexDevice.cbGetInfo = function(opCode, dataType, data) {
                var v = eval("(" + data + ")");
                if (f) {
                    f(v);
                }
            };
            uexDevice.getInfo(type);
        }
        return this;
    },
    /**********音频流播放插件**********/
   playAudio:function(path){
       /*是否开启音频播报*/
       var yuyingbobao = b.lsget("yuyingbobao") || "";
       if (yuyingbobao == "true"){
           uexAudio.stop();
           uexAudio.open(path);
           uexAudio.play(0);   
       }    
   },
    /**********打电话插件**********/
    call : function(no) {
        uexCall.dial(no);
    },
    /**********发送短信插件**********/
    sendSMS : function(no, t) {
        uexSMS.open(no, t);
    },
    /**********日期选择控件**********/
    datefield : function() {
        this.getDate = function(d, f) {
            uexControl.cbOpenDatePicker = function(opId, dataType, data) {
                f(data);
            }
            uexControl.openDatePicker(d.getFullYear(), d.getMonth() + 1, d.getDate());
        }
        return this;
    },
    /**********时间选择控件**********/
    timefield : function() {
        this.getTime = function(d, f) {
            uexControl.cbOpenTimePicker = function(opId, dataType, data) {
                f(data);
            }
            uexControl.openTimePicker(d.getHours(), d.getMinutes());
        }
        return this;
    },
    /**********年月选择控件**********/
    dateNoDayField : function() {
        this.getDateNoDay = function(d, f) {
            uexControl.cbOpenDatePickerWithoutDay = function(opId, dataType, data) {
                f(data);
            }
            uexControl.openDatePickerWithoutDay(d.getFullYear(), d.getMonth() + 1);
        }
        return this;
    },
    /**********相机插件**********/
    camera : function() {
        this.open = function(f) {
            uexCamera.cbOpen = function(opCode, dataType, data) {
                f(data);
            }
            uexCamera.open();
        }
        return this;
    },
    /**********位置插件**********/
    location : function() {
        var pos_lat,
            pos_log;
        this.open = function(f, f2) {
            uexLocation.cbOpenLocation = function(opCode, dataType, data) {
                if (f) {
                    f(data == "0");
                }
            }
            uexLocation.onChange = function(lat, log) {
                pos_lat = lat;
                pos_log = log;
                if (f2) {
                    f2(lat, log);
                }
            }
            uexLocation.openLocation();
        }
        this.getAddress = function(f) {
            uexLocation.cbGetAddress = function(opCode, dataType, data) {
                f(data);
            }
            uexLocation.getAddress(pos_lat, pos_log, 0);
        }
        this.close = function() {
            uexLocation.closeLocation();
        }
        return this;
    },
    /**********二维码插件**********/
    scanner : function() {
        this.open = function(f) {
            uexScanner.cbOpen = function(opCode, dataType, data) {
                var v = eval("(" + data + ")");
                f(true, v.type, v.code);
            }
            uexWidgetOne.cbError = function(data) {
                f(false);
            }
            uexScanner.open();
        }
        return this;
    },

    /**********百度地图插件**********/
    baiduMap : function() {

        /*缓存中的uexBaiduMap_state 为地图的显示状态: 当值close代表未打开过, show 代表被显示, hide代表被隐藏 */

        /*当前地图中 创建的标注Id 集合*/
        var array_markerIds = [];

        /*打开地图*/
        this.open = function(left, top, width, height, log, lat, fun_open, fun_MapClickListener) {

            //this.close();

            /*打开地图后的回调处理*/
            uexBaiduMap.cbOpen = function() {
                /*设置地图显示比例*/
                uexBaiduMap.setZoomLevel(15);
                /*允许缩放*/
                uexBaiduMap.setZoomEnable(1);
                /*允许旋转*/
                uexBaiduMap.setRotateEnable(1);
                /*允许指南针*/
                uexBaiduMap.setCompassEnable(1);
                /*允许手势移动*/
                uexBaiduMap.setScrollEnable(1);

                if (fun_open) {/*地图打开 后的 回调处理*/
                    fun_open();
                }
            }
            /*点击地图时的回调处理 */
            // uexBaiduMap.onMapClickListener = function(json) {
                // var obj_data = b.s2j(json);
                // if (fun_MapClickListener) {
                    // fun_MapClickListener(obj_data);
                // }
            // }

            uexBaiduMap.open(left, top, width, height, log, lat);

            /*标记地图状态为被显示*/
            this.setState("show");
        },
        /*获取地图状态*/
        this.getState = function() {
            return b.ifnull(b.lsget("uexBaiduMap_state"), "close");
        },

        /*关闭地图*/
        this.close = function() {
            /*标记地图状态为 关闭*/
            this.setState("close");
            b.lsremove("uexBaiduMap_state");
            uexBaiduMap.close();
        },
        /*关闭地图*/
        this.clearState = function() {
            /*标记地图状态为 关闭*/
            this.setState("close");
        },
        /*设置地图状态*/
        this.setState = function(v) {
            b.lsset({
                uexBaiduMap_state : v
            });
        },
        /*隐藏地图*/
        this.hide = function() {
            if (this.getState() == "show") {
                uexBaiduMap.hideMap();
                this.setState("hide");
            }
        },
        /*隐藏地图*/
        this.show = function() {
            if (this.getState() == "hide") {
                uexBaiduMap.showMap();
                this.setState("show");
            }
        },
        /*设置地图的比例级别*/
        this.setZoomLevel = function(zoomLevel) {
            uexBaiduMap.setZoomLevel(zoomLevel);
        },
        /*创建默认标注*/
        this.addMarker = function(id, log, lat) {
            if (!this.hasMarkerId(id)) {
                array_markerIds.push(id);
            }
            var data = [{
                id : id,
                bubble : {
                    //title : '经度:' + log + ',纬度:' + lat
                    title : '我的位置'
                },
                longitude : log,
                latitude : lat,
                icon : this.getIconMarker("my_marker1.png")
            }];
            var dataStr = JSON.stringify(data);
            uexBaiduMap.addMarkersOverlay(dataStr);
        },
        /*创建自定义标注*/
        this.addMarker2 = function(p) {
            for (var i = 0; i < p.length; i++) {
                if (!this.hasMarkerId(p[i].id)) {
                    array_markerIds.push(p[i].id);
                }
            };

            var dataStr = JSON.stringify(p);
            var ids = uexBaiduMap.addMarkersOverlay(dataStr);
            if (ids) {
                alert("添加失败");
            }
        },

        /*显示标注气泡*/
        this.showBubble = function(id) {
            setTimeout(function() {
                uexBaiduMap.showBubble(id);
            }, 500)
        }
        /*更新标注*/
        this.setMarker = function(id, log, lat) {
            var makerInfo = {
                makerInfo : {
                    latitude : lat,
                    bubble : {
                        title : '经度:' + log + ',纬度:' + lat
                    },
                    longitude : log,
                    icon : this.getIconMarker("my_marker1.png")
                }
            };
            var jsonStr = JSON.stringify(makerInfo);
            uexBaiduMap.setMarkerOverlay(id, jsonStr);
        },
        /*更新标注*/
        this.setMarker2 = function(id, p) {
            var jsonStr = JSON.stringify(p);
            uexBaiduMap.setMarkerOverlay(id, jsonStr);
        },
        /*设置中心点*/
        this.mapCenter = function(log, lat) {
            uexBaiduMap.setCenter(log, lat);
        },
        /*清除指定的标注*/
        this.clearMarker = function(id) {
            this.removeMarkerId(id);
            uexBaiduMap.removeMakersOverlay('["' + id + '"]');
        },

        /*移除 指定的标注ID*/
        this.removeMarkerId = function(id) {
            for (var i = 0; i < array_markerIds.length; i++) {
                if (array_markerIds[i] == id) {
                    array_markerIds[i] = "";
                }
            };
        },
        /*是否存在 指定的标注ID*/
        this.hasMarkerId = function(id) {
            for (var i = 0; i < array_markerIds.length; i++) {
                if (array_markerIds[i] == id) {
                    return true;
                }
            };
            return false;
        },

        /*清除所有的标注*/
        this.clearAllMarker = function() {
            for (var i = 0; i < array_markerIds.length; i++) {
                var id = array_markerIds[i];
                if (!b.isnull(id)) {
                    uexBaiduMap.removeMakersOverlay('["' + id + '"]');
                }

            };
        },
        /*兴趣点搜索*/
        this.poiSearch = function(log, lat, city, keyword, f) {
            uexBaiduMap.cbPoiSearchResult = function(json) {
                var obj_data = b.s2j(json);
                if (f) {
                    f(obj_data);
                }
            }
            var data = {
                longitude : log,
                latitude : lat,
                radius : "1000",
                searchKey : keyword,
                pageNum : "0"
            };
            var jsonStr = JSON.stringify(data);
            uexBaiduMap.poiNearbySearch(jsonStr);
        },
        /*获取当前坐标位置*/
        this.getLocation = function(f) {

            /*获取当前位置 的回调*/
            uexBaiduMap.cbCurrentLocation = function(json) {
                var obj_data = b.s2j(json);
                if (f) {
                    f(obj_data);
                }
            }

            uexBaiduMap.getCurrentLocation();
        },
        /*根据 坐标 获取 对应的中文地址*/
        this.getAddress = function(log, lat, f) {
            uexBaiduMap.cbReverseGeoCodeResult = function(json) {
                var obj_data = b.s2j(json);
                if (f) {
                    f(obj_data);
                }
            }
            var data = {
                longitude : log,
                latitude : lat
            };
            var jsonStr = JSON.stringify(data);
            uexBaiduMap.reverseGeocode(jsonStr);
        },
        /*通过地址获取 坐标*/
        this.getPos = function(city, address, f) {
            /*通过地址获取 坐标 回调*/
            uexBaiduMap.cbGeoCodeResult = function(json) {
                var obj_data = b.s2j(json);
                if (f) {
                    f(obj_data);
                }
            }
            var data = {
                city : city,
                address : address
            };
            var jsonStr = JSON.stringify(data);
            uexBaiduMap.geocode(jsonStr);
        },
        /*线路规划*/
        this.searchRoutePlan = function(id, beginLog, beginLat, endLog, endLat) {
            var data = {
                id : id,
                type : "0",
                start : {
                    longitude : beginLog,
                    latitude : beginLat
                },
                end : {
                    longitude : endLog,
                    latitude : endLat
                }
            };
            var jsonStr = JSON.stringify(data);
            uexBaiduMap.searchRoutePlan(jsonStr);
        },
        /*标注的图标链接*/
        this.getIconMarker = function(iconName) {
            //var str_iconMarker = "../../icons/map_marker4.png?r=" + b.random();
            var str_iconMarker = pc.SIP.replace('/Data/App/', '') + "/UI/resources/images/app/" + iconName;
            //var str_iconMarker = "http://www.iconpng.com/png/mapmarkers/marker_inside_azure.png";
            //var str_iconMarker = "http://www.iconpng.com/png/mapmarkers/marker_inside_azure.png?r=" + b.random();
            return str_iconMarker;
        }

        return this;
    },
    /*QQ插件，QQ分享*/
    QQ : function(appId, sharedFun) {
        /*图片浏览器是否安装*/
        var bool_uexImg = false;
        /*微信是否安装*/
        var bool_ok = false;
        /*本地分享时的参数*/
        var json_shareLocal = {};

        /*选择本地图片分享*/
        var str_localImgShareType = "2";

        /*验证图片浏览器是否安装*/
        if ( typeof (uexImage) != 'undefined') {
            bool_uexImg = true;
        }

        /*检查QQ是否安装*/
        uexQQ.cbIsQQInstalled = function(opId, dataType, data) {
            bool_ok = data == 0;
        }
        /*分享QQ后回调函数*/
        uexQQ.cbShareQQ = function(opId, dataType, data) {
            if (sharedFun) {
                sharedFun(data);
            }
        }
        /*检查QQ是否安装了*/
        uexQQ.isQQInstalled();

        /*选择本地图片分享*/
        this.cbPick = function(error, info) {
            if (error == 0) {
                if (info.detailedImageInfo) {
                    var image = info.detailedImageInfo[0].localPath;
                    if (str_localImgShareType == "toQQZone") {
                        json_shareLocal.imageUrl = image
                        uexQQ.shareImgTextToQZone(appId, JSON.stringify(json_shareLocal));
                    } else {
                        var json = {
                            imageLocalUrl : image,
                            appName : "uexQQ",
                            cflag : "2"
                        };
                        uexQQ.shareLocalImgToQQ(appId, JSON.stringify(json));
                    }
                }
            }
        }
        /*分享URL图片或文字到QQ*/
        this.shareWebImgTextToQQ = function(title, remark, url, imgurl, flag) {
            if (bool_ok == false) {
                b.alert("未安装QQ");
                return;
            }
            var json_params = {
                title : title,
                summary : remark,
                targetUrl : url,
                imageUrl : imgurl,
                appName : "uexQQ",
                cflag : flag || 2
            };
            uexQQ.shareWebImgTextToQQ(appId, JSON.stringify(json_params));
        }
        /*分享URL图片或文字到QQ空间*/
        this.shareImgTextToQZone = function(title, remark, url, imgurl) {
            if (bool_ok == false) {
                b.alert("未安装QQ");
                return;
            }
            var json_params = {
                title : title,
                summary : remark,
                targetUrl : url,
                imageUrl : appcan.isArray(imgurl) ? imgurl : [imgurl]
            };
            uexQQ.shareImgTextToQZone(appId, JSON.stringify(json_params));
        }
        /*分享本地图片到QQ*/
        this.shareLocalImgToQQ = function() {
            if (bool_ok == false) {
                b.alert("未安装QQ");
                return;
            }
            if (bool_uexImg == false) {
                b.alert("未安装图片浏览插件");
                return;
            }
            str_localImgShareType = "toQQ";

            var data = {
                min : 1,
                max : 1,
                quality : 0.8,
                detailedInfo : true,
                style : 1
            };
            uexImage.openPicker(data, this.cbPick);
        }
        /*分享本地图片到QQ空间*/
        this.shareLocalImgToQZone = function(title, remark, url) {
            if (bool_ok == false) {
                b.alert("未安装QQ");
                return;
            }
            if (bool_uexImg == false) {
                b.alert("未安装图片浏览插件");
                return;
            }
            str_localImgShareType = "toQQZone";
            json_shareLocal = {
                title : title,
                summary : remark,
                targetUrl : url,
            }

            var data = {
                min : 1,
                max : 1,
                quality : 0.8,
                detailedInfo : true,
                style : 1
            };
            uexImage.openPicker(data, this.cbPick);
        }

        return this;
    },
    /*微信分享*/
    weixin : function(appId, sharedFun) {
        /*图片浏览器是否安装*/
        var bool_uexImg = false;
        /*微信是否安装*/
        var bool_ok = false;
        /*本地分享时的参数*/
        var json_shareLocal = {};

        /*验证图片浏览器是否安装*/
        if ( typeof (uexImage) != 'undefined') {
            bool_uexImg = true;
        }
        /*微信授权回调*/
        uexWeiXin.cbRegisterApp = function(opCode, dataType, data) {
            if (data != 0) {
                b.alert("微信授权失败");
            }
        }
        /*注册APPID*/
        uexWeiXin.registerApp(appId);

        /*微信是否安装回调*/
        uexWeiXin.cbIsWXAppInstalled = function(opId, dataType, data) {
            bool_ok = data == 0;
            if (bool_ok) {
                /*微信文本分享回调*/
                uexWeiXin.cbShareTextContent = function(data) {
                    if (sharedFun != null) {
                        sharedFun("shareText", data == 0);
                    }
                }
                /*微信文本分享回调*/
                uexWeiXin.cbShareImageContent = function(data) {
                    if (sharedFun != null) {
                        sharedFun("shareImage", data == 0);
                    }
                }
                /*微信文本分享回调*/
                uexWeiXin.cbShareLinkContent = function(data) {
                    if (sharedFun != null) {
                        sharedFun("shareLink", data == 0);
                    }
                }
            }
        }
        /*检查是否安装微信*/
        uexWeiXin.isWXAppInstalled();

        this.cbPick = function(error, info) {
            if (error == 0) {
                if (info.detailedImageInfo) {
                    image = info.detailedImageInfo[0].localPath;
                    json_shareLocal.image = image;
                    uexWeiXin.shareImageContent(JSON.stringify(json_shareLocal));
                }
            }
        }
        /*微信文字分享*/
        this.shareTextContent = function(type, text) {
            if (bool_ok == false) {
                b.alert("未安装微信");
                return;
            }
            var data = {
                text : text,
                scene : type
            };
            uexWeiXin.shareTextContent(JSON.stringify(data));
        }
        /*微信图片分享*/
        this.shareImageContent = function(type, title, simg) {
            if (bool_ok == false) {
                b.alert("未安装微信");
                return;
            }
            if (bool_uexImg == false) {
                b.alert("未安装图片浏览插件");
                return;
            }
            json_shareLocal = {
                title : title,
                scene : type,
                thumbImg : simg /*要求图片32kb一下*/
            }

            var data = {
                min : 1,
                max : 1,
                quality : 0.8,
                detailedInfo : true,
                style : 1
            };
            uexImage.openPicker(data, this.cbPick);

        }
        /*微信链接分享*/
        this.shareLinkContent = function(type, title, remark, simg, url) {
            try {
                if (bool_ok == false) {
                    b.alert("未安装微信");
                    return;
                }
                var data = {
                    title : title,
                    scene : type,
                    thumbImg : simg, /*要求图片32kb一下*/
                    wedpageUrl : url,
                    description : remark
                };
                uexWeiXin.shareLinkContent(JSON.stringify(data));
            } catch(e) {
                alert(e.message);
            }

        }
        return this;
    }
    /***************************/

}
